;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;  Routines : 
; 
;      - d_scalar : see_scalar, see_zone_scalar
; 
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

pro d_scalar,GV,SC,z
  
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; Check if we have all variables needed
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  

  ans1 = 'plop'

  if z eq 1 then begin
     if not GV.haskey('rbcz') then begin
        ans1 = ''
        print,'Enter radiative core proportion (between 0 and 1)'
        read,ans1
        GV['rbcz'] = double(ans1)
     endif
  endif

  if not SC.haskey('quantities') then begin
     l = []
     print,'Choose a list of quantities'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     SC['quantities'] = l
  endif
  if not SC.haskey('sq') then begin
     print,'Choose a statistival quantity : [1,2,3] = [mean,min,max]'
     read,ans1
     SC['sq'] = long(ans1)
  endif
  if not SC.haskey('recperfile') then begin
     print,'Choose the number of record per file '
     read,ans1
     SC['recperfile'] = long(ans1)
  endif
  if (z eq 1 ) and not SC.haskey('zone') then begin ; only in the scalar_zone routine
     print,'Choose a zone variable (0 for both, 1 only CZ, 2 only RZ)' 
     read,ans1
     SC['zone'] = long(ans1)
  endif
  if not SC.haskey('legendd') then SC['legendd'] = 2

  lq = SC['quantities']

  ; Often used variables for scalar (choose quantities eq 0 to get it)
  if lq[0] eq 0 then begin 
     if (GV['hydro'] eq 0) then begin
        lq = [1,9,10,12]
     endif else begin
        lq = [1,9,61,65,66,67]
     endelse
  endif
  
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
; Call to the scalar routines : global or zone separated
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  

  nbf = long((GV['eend']-GV['start'])/GV['jump']+1)

  if z eq 0 then begin
     see_scalar2,GV['dir'],lq,SC['sq'],SC['recperfile'],nbf,GV['start'],$
                 GV['jump'],glob=GV['glob'],sc=GV['sc'],notquiet=GV['notquiet'],$
                 swap=GV['swap'],psf=GV['psf'],wnd=GV['wnd'],legendd=SC['legendd']
  endif else begin
     see_zone_scalar2,GV['dir'],lq,SC['sq'],sc['recperfile'],nbf,$
                      GV['start'],GV['jump'],zone=SC['zone'],rbcz=GV['rbcz'],$
                      glob=GV['glob'],sc=GV['sc'],notquiet=GV['notquiet'],swap=GV['swap'],$
                      psf=GV['psf'],wnd=GV['wnd']
  endelse
  GV['wnd'] = GV['wnd']+1
end
