;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;  Routines : 
; 
;      - d_flux : see_flux_balance
;      - d_shav : see_shav 
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

pro d_flux,GV

  if not GV.haskey('lstar') then begin
     ans1 = ''
     print,'Enter stellar luminosity'
     read,ans1
     GV['lstar'] = double(ans1)
  endif
  if not GV.haskey('rstar') then begin
     ans1 = ''
     print,'Enter stellarradius'
     read,ans1
     GV['rstar'] = double(ans1)
  endif
  
  print,GV['lstar'],GV['rstar']
  
  see_flux_balance2,GV['dir'],GV['iteration'],GV['recnum'],lstar=GV['lstar'],$
                    rstar=GV['rstar'],swap=GV['swap'],psf=GV['psf'],glob=GV['glob'],$
                    notquiet=GV['notquiet'],wnd=GV['wnd']
  GV['wnd'] = GV['wnd']+1
end

pro d_shav,GV,SAs

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; Check if we have all variables needed
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  

  ans1 = 'plop'

  if not GV.haskey('rbcz') then begin
     ans1 = ''
     print,'Enter radiative core proportion (between 0 and 1)'
     read,ans1
     GV['rbcz'] = double(ans1)
  endif

  if not SAs.haskey('quantities') then begin
     l = []
     print,'Choose a list of quantities'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     SAs['quantities'] = l
  endif
  if not SAs.haskey('sq') then begin
     l = []
     print,'Choose a list of statistical quantities'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     SAs['sq'] = l
  endif

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
; Call to the see_shav routine
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  

  lq    = SAs['quantities']  
  sq    = SAs['sq'] 
  
  nb_lq = size(lq) & nb_lq = nb_lq[1]
  nb_sq = size(sq) & nb_sq = nb_sq[1]

  for qq=0,nb_lq-1 do begin
     if qq ge nb_sq then sqq = sq[nb_sq-1] else sqq = sq[qq] ; if list of sq smaller that quantity list then it is completed by its last value
     see_shav2,GV['dir'],lq[qq],sqq,GV['iteration'],GV['recnum'],swap=GV['swap'],$
               glob=GV['glob'],sc=GV['sc'],notquiet=GV['notquiet'],psf=GV['psf'],$
               rbcz=GV['rbcz'],wnd=GV['wnd']
     GV['wnd'] = GV['wnd']+1
  endfor

end
