;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;  Routines : 
;    
;      - d_shsl     : see_shsl2, see_envision_shsl2
;      - d_mov_shsl : movie_shsl2
;      - d_spectra  : get_spectra2, see_spectra2
; 
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

pro d_shsl,GV,SHs,z
  
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; Check if we have all variables needed
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  

  ans1 = 'plop'
  if not GV.haskey('rstar') then begin
     ans1 = ''
     print,'Enter stellarradius'
     read,ans1
     GV['rstar'] = double(ans1)
  endif

  if not SHs.haskey('quantities') then begin
     l = []
     print,'Choose a list of quantities'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     SHs['quantities'] = l
  endif
  if not SHs.haskey('sq') then begin
     l = []
     print,'Choose a list of statistical quantities'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     SHs['sq'] = l
  endif
  if (z eq 1) and not SHs.haskey('depth') then begin
     l = []
     print,'Choose a list of depths'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     SHs['depth'] = l
  endif
  if not SHs.haskey('icutmax') then begin
     print,'Enter number of shells (minus 1)'
     read,ans1
     SHs['icutmax'] = long(ans1)
  endif
  if not SHs.haskey('ortho') then begin
     print,'Enter a sphere projection number'
     read,ans1
     SHs['ortho'] = long(ans1)
  endif
  if (z eq 1) and not SHs.haskey('horiz') then begin
     print,'Do you want to plot the horizon ? (0/1)'
     read,ans1
     SHs['horiz'] = long(ans1)
  endif

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
; Call to the see_eqsl routine
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  

  lq      = SHs['quantities']
  sq      = SHs['sq']
  if z eq 1 then de = SHs['depth']

  nb_lq = size(lq) & nb_lq = nb_lq[1]
  nb_sq = size(sq) & nb_sq = nb_sq[1]
  
  nb_de = 0
  if z eq 1 then begin
     nb_de = size(de)
     nb_de = nb_de[1] 
  endif

  print,nb_de,nb_lq
  n_max = max([nb_de,nb_lq])
  print,n_max

  for qq=0,n_max-1 do begin
     if qq ge nb_sq then sqq = sq[nb_sq-1] else sqq = sq[qq]
     if qq ge nb_lq then lqq = lq[nb_lq-1] else lqq = lq[qq]
     print,qq
     if z eq 0 then begin
        see_shsl2,GV['dir'],lqq,sqq,GV['iteration'],GV['recnum'],icutmax=SHs['icutmax'],$
                  rstar=GV['rstar'],glob=GV['glob'],sc=GV['sc'],notquiet=GV['notquiet'],$
                  swap=GV['swap'],opl=GV['opl'],psf=GV['psf'],wnd=GV['wnd'],tv=1,ortho=Shs['ortho']
     endif else begin
        if qq ge nb_de then deq = de[nb_de-1] else deq = de[qq]
        see_envision_shsl2,GV['dir'],lqq,sqq,GV['iteration'],GV['recnum'],depth=deq,$
                           rstar=GV['rstar'],horiz=SHs['horiz'],glob=GV['glob'],sc=GV['sc'],$
                           notquiet=GV['notquiet'],swap=GV['swap'],opl=GV['opl'],psf=Gv['psf'],$
                           wnd=GV['wnd'],tv=1,ortho=SHs['ortho']
     endelse
     GV['wnd'] = GV['wnd']+1
  endfor
end

pro d_mov_shsl,GV,SHs,z
  
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; Check if we have all variables needed
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
  
  ans1 = 'plop'
  if not GV.haskey('rstar') then begin
     ans1 = ''
     print,'Enter stellarradius'
     read,ans1
     GV['rstar'] = double(ans1)
  endif
  if not SHs.haskey('quantities') then begin
     l = []
     print,'Choose a list of quantities'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     SHs['quantities'] = l
  endif
  if not SHs.haskey('sq') then begin
     l = []
     print,'Choose a list of statistical quantities'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     SHs['sq'] = l
  endif
  if not SHs.haskey('to') then begin
     print,'Choose a time offset'
     read,ans1
     SHs['to'] = double(ans1)
  endif
  if not SHs.haskey('base') then begin
     print,'Choose an offset number of output file'
     read,ans1
     SHS['base'] = long(ans1)
  endif
  if not SHs.haskey('recperfile') then begin
     print,'Choose the number of record per files '
     read,ans1
     SHs['recperfile'] = long(ans1)
  endif
  if (z eq 1) and not SHs.haskey('depth') then begin
     l = []
     print,'Choose a list of depths'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     SHs['depth'] = l
  endif
  if not SHs.haskey('icutmax') then begin
     print,'Enter number of shells (minus 1)'
     read,ans1
     SHs['icutmax'] = long(ans1)
  endif
  if not SHs.haskey('ortho') then begin
     print,'Enter a sphere projection number'
     read,ans1
     SHs['ortho'] = long(ans1)
  endif
  if (z eq 1) and not SHs.haskey('horiz') then begin
     print,'Do you want to plot the horizon ? (0/1)'
     read,ans1
     SHs['horiz'] = long(ans1)
  endif
  
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
; Call to the shsl movie routine
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  

  lq      = SHs['quantities']
  sq      = SHs['sq']
  if z eq 1 then de = SHs['depth']

  nb_lq = size(lq) & nb_lq = nb_lq[1]
  nb_sq = size(sq) & nb_sq = nb_sq[1]
  
  nb_de = 0
  if z eq 1 then begin 
     nb_de = size(de) 
     nb_de = nb_de[1]
  endif
  n_max = max([nb_de,nb_lq])

  nbf = long((GV['eend']-GV['start'])/GV['jump']+1)
  for qq=0,n_max-1 do begin
     if qq ge nb_sq then sqq = sq[nb_sq-1] else sqq = sq[qq]
     if qq ge nb_lq then lqq = lq[nb_lq-1] else lqq = lq[qq] 
     if z eq 1 then begin
        if qq ge nb_de then deq = de[nb_de-1] else deq = de[qq]
     endif
     if (z eq 1) then ddepth = deq else ddepth = -SHs['icutmax']
     movie_shsl2,GV['dir'],lqq,sqq,SHs['recperfile'],nbf,GV['start'],GV['jump'],$
                 rstar=GV['rstar'],depth=ddepth,base=SHs['base'],to=SHs['to'],$
                 glob=GV['glob'],sc=GV['sc'],notquiet=GV['notquiet'],swap=swap,$
                 wnd=GV['wnd'],tv=1,ortho=SHs['ortho']
     GV['wnd'] = GV['wnd']+1
  endfor
end

pro d_spectra,GV,SP
  
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; Check if we have all variables needed
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  

  ans1 = 'plop'
  if not GV.haskey('rstar') then begin
     ans1 = ''
     print,'Enter stellar radius'
     read,ans1
     GV['rstar'] = double(ans1)
  endif
   if not GV.haskey('rbcz') then begin
     ans1 = ''
     print,'Enter proportion of the radiative core (between 0 and 1)'
     read,ans1
     GV['rbcz'] = double(ans1)
  endif
  if not SP.haskey('recperfile') then begin
     print,'Choose the number of record per file '
     read,ans1
     SP['recperfile'] = long(ans1)
  endif
  if not SP.haskey('icutmax') then begin
     print,'Enter number of shells (minus 1)'
     read,ans1
     SP['icutmax'] = long(ans1)
  endif
  if not SP.haskey('build') then begin
     print,'Do you want to recompile spectra ? (0/1)'
     read,ans1
     SP['build'] = long(ans1)
  endif
  if not SP.haskey('file') then begin
     print,'Enter a spectra filename'
     read,ans1
     SP['file'] = ans1
  endif

  file = SP['file']

  if SP['build'] eq 0 then begin
     nfiles = long((GV['eend']-GV['start'])/GV['jump']+1)
     read_spectra2,GV['dir'],SP['recperfile'],nfiles,GV['start'],GV['jump'],icutmax=icutmax,sq=0,outfile=file,swap=swap,glob=GV['glob'],sc=GV['sc'],notquiet=2
     if GV['hydro'] eq 1 then read_spectra2,GV['dir'],SP['recperfile'],nfiles,GV['strat'],GV['jump'],icutmax=icutmax,sq=1,outfile=file,swap=swap,glob=GV['glob'],sc=GV['sc'],notquiet=2
  endif

  spectra2,file,icutmax,fshsl=GV['dir']+'/SHSL/shsl_0'+strcompress(iter,/r),rstar=GV['rstar'],mag=GV['hydro'],notquiet=GV['notquiet']$
           ,rbcz=Gv['rbcz'],swap=swap,wnd=GV['wnd']
  if GV['hydro'] eq 1 then spectra2,file,icutmax,fshsl=GV['dir']+'/SHSL/shsl_0'+strcompress(iter,/r),rstar=GV['rstar'],mag=GV['hydro'],$
                                    notquiet=GV['notquiet'],rbcz=Gv['rbcz'],swap=swap,wnd=GV['wnd'],mag=1

  GV['wnd']=GV['wnd']+1
end
