@get_names


function search_dd,dd,look

  case 1 of
     isa(look,/string) eq 1 : begin
        print,'You are looking for an index ...'
        if dd.HasKey(look) eq 0 then begin
           print,'... nut no variable name matches the input string'
        endif
        res = dd(look)
     end
     (isa(look,/long) eq 1) or (isa(look,/int) eq 1): begin
        print,'You are looking for a variable name ...'
        if dd.HasKey(strcompress(look,/r)) eq 0 then begin
           print,'... nut no index matches the input integer'
        endif
        res = dd(strcompress(look,/r))
     end 
     else: begin
        print,'Your choice is neither a string neither an integer : FATAL ERROR'
        res = -1
     end
  end
  return,res
end

pro print_dd,dd
  list_keys = dd.Keys()
  n_keys = size(list_keys) & n_keys = n_keys(1)
  
  if key eq 0 then begin
     print,' '
     print,dd(key)
     print,' '
  endif
  
  for key = 1,(n_keys-1)/2 do begin
     print,key,' -- ',dd(key)
  endfor
  
end

pro check_variables

  print,'Outputs : '
  print,'1: Scalar (integrated over the entire domain)'
  print,'2: SHAV (integrated over theta and phi)'
  print,'3: AZAV (integrated over phi)'
  print,'4: SHSL (fixed radius, theta and phi variables)'
  print,'5: EQSL (fixed latitude, rad and phi variables)'
  print,'6: POSL (fixed longitude, rad and theta variables)'
  print,'7: Bulk (3D output)'
  print,' '
  print,'Choose an output'
  read,choice

  output = 1+lindgen(7)
  pos    = where(output eq choice)

  case choice of
     1: dd = dict_scalar()
     2: dd = dict_2D('ShellAverages')
     3: dd = dict_2D('AzimuthalAverages')
     4: dd = dict_2D('ShellSlices')
     5: dd = dict_2D('EquatorialSlices')
     6: dd = dict_2D('PolarSlices')
     7: dd = dict_2D('')
     else: return
  end

  print,'What are you looking for ? '
  print,'1: All names and index'
  print,'2: An index (knowing the name)'
  print,'3: A name (knowing the index'
  read,choice_search

  case choice_search of
     1: print_dict,dd
     2: begin
        name = ''
        while name eq '' do begin
           print,'Which name ?'
           read,name
           if isa(name,/string) eq 0 then name = ''
        endwhile
        res = search_dd(dd,name)
        print,'Result : ',res
     end
     3: begin
        index = 0
        while index eq 0 do begin
           print,'Which index ?'
           read,index
           if isa(index,/int) eq 0 and isa(index,/long) eq 0 then index = 0
        endwhile
        res = search_dd(dd,index)
        print,'Result : ',res
     end
     else:return
  end
end
