@call_scalar
@call_shav
@call_eqsl
@call_shsl

pro choice,choice,res,GV
  
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; Check if GV variables are OK
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

  ; Lists of 'snapshot' and 'time' routines 
  lss = ['1','4','5','7','8','12','19']
  ltt = ['2','3','6','9','10','11','13','14','15','16','17','18','20']

  ; Shared variables for all routines
  if GV.HasKey('dir')     eq 0 then begin
     dir = ''
     print,'Enter a data directory ("dir" is missing in "Global Variables" section)'
     read,dir
     GV['dir'] = dir
  endif
  if GV.hasKey('hydro')    eq 0 then begin
     h = 0
     print,'Is the case only hydrodynamical ? (0/1) ("hydro" is missing in "Global Variables" )'
     read,h
     GV['hydro'] = h
  endif
  if GV.HasKey('glob')     eq 0 then GV['glob']     = 0
  if GV.HasKey('sc')       eq 0 then GV['sc']       = 1
  if GV.HasKey('notquiet') eq 0 then GV['notquiet'] = 1
  if GV.HasKey('swap')     eq 0 then GV['swap']     = 0
  if GV.HasKey('opl')      eq 0 then GV['opl']      = 0
  if GV.HasKey('psf')      eq 0 then GV['psf']      = 0
  if GV.haskey('wnd')      eq 0 then GV['wnd']      = 0
  
  ans1 = ''
  if where(lss eq choice) gt -1 then begin ; Variables for 'snapshot' routines
     if not GV.haskey('iteration')       then begin
        print,'Choose the iteration of the file'
        read,ans1
        GV['iteration'] = long(ans1)
     endif
     if not GV.haskey('recnum')       then begin
        print,'Choose a record number in the file'
        read,ans1
        GV['recnum'] = long(ans1)
     endif
  endif else if where(ltt eq choice) gt -1 then begin ; Variables for 'time' routines
     if not GV.haskey('start')       then begin
        print,'Choose a starting file'
        read,ans1
        GV['start'] = long(ans1)
     endif
     if not GV.haskey('jump')        then begin
        print,'Choose a jump interval'
        read,ans1
        GV['jump' ] = long(ans1)
     endif
     if not GV.haskey('eend')        then begin
        print,'Choose an ending file'
        read,ans1
        GV['eend']  = long(ans1)
     endif
  endif else begin
     print,'Routine neither "snapshot" nor "time" ...'
  endelse

  case choice of 
     '0': begin
        name=''
        while name eq '' do begin
           print,'Enter new file name : '
           read,name
        endwhile
        GV['dir']=name
        return
   end
     '1' : begin
        d_flux,GV
     end
     '2' : begin
        if res.haskey('Scalar') eq 0 then SC = dictionary() else SC = res['Scalar']
        d_scalar,GV,SC,0
     end
     '3' : begin
        if res.haskey('Scalar') eq 0 then SC = dictionary() else SC = res['Scalar'] 
         d_scalar,GV,SC,1
      end
     '4' : begin
        if res.haskey('ShellAverages') eq 0 then SAs = dictionary() else SAs = res['ShellAverages']
        d_shav,GV,SAs
     end
     '5' : begin
        if res.haskey('EquatorialSlices') eq 0 then EQs = dictionary() else EQs = res['EquatorialSlices']
        d_eqsl,GV,EQs
     end
     '6' : begin
        if res.haskey('EquatorialSlices') eq 0 then EQs = dictionary() else EQs = res['EquatorialSlices']
        d_mov_eqsl,GV,EQs
     end
     '7' : begin
        if res.haskey('ShellSlices') eq 0 then SHs = dictionary() else SHs = res['ShellSlices']
        d_shsl,GV,SHs,0
     end
     '8' : begin
        if res.haskey('ShellSlices') eq 0 then SHs = dictionary() else SHs = res['ShellSlices']
         d_shsl,GV,SHs,1
      end
     '9' : begin
        if res.haskey('ShellSlices') eq 0 then SHs = dictionary() else SHs = res['ShellSlices']
        d_mov_shsl,GV,SHs,0
     end
     '10' : begin
        if res.haskey('ShellSlices') eq 0 then SHs = dictionary() else SHs = res['ShellSlices']
        d_mov_shsl,GV,SHs,1
     end
     '11': begin
        if res.haskey('Spectra') eq 0 then SP = dictionary() else SP = res['Spectra']
        d_spectra,GV,SP
     end
     '12' : begin
        if res.haskey('AzimuthalAverages') eq 0 then AZ = dictionary() else AZ = res['AzimuthalAverages']
        d_azav,GV,AZ,0
     end
     '13' : begin
        if res.haskey('AzimuthalAverages') eq 0 then AZ = dictionary() else AZ = res['AzimuthalAverages']
        d_azav,GV,AZ,1
     end
     '14' : begin
        if res.haskey('AzimuthalAverages') eq 0 then AZ = dictionary() else AZ = res['AzimuthalAverages']
        d_mov_azav,GV,AZ
     end
     '15': begin
        if res.haskey('ButterflyDiagram') eq 0 then BD = dictionary() else BD = res['ButterflyDiagram']
        d_butterfly,GV,BD
     end 
     '16': begin
        if res.haskey('ButterflyDiagram') eq 0 then BD = dictionary() else BD = res['ButterflyDiagram']
        d_butterfly,GV,BD,0
     end 
     '17': begin
        if res.haskey('ButterflyDiagram') eq 0 then BD = dictionary() else BD = res['ButterflyDiagram']
        d_rad_butterfly,GV,BD
     end 
     '18': begin
        if res.haskey('AngularMomentum') eq 0 then AM = dictionary() else AM = res['AngularMomentum']
        d_angmom,GV,AM
     end
     '19': begin
        if res.haskey('MagneticFieldProduction') eq 0 then MFP = dictionary() else MFP = res['MagneticFieldProduction']
        d_magfieldprod,GV,MFP
     end
     '20': begin
        if res.haskey('AlphaOmegaEffect') eq 0 then AOE = dictionary() else AOE = res['AlphaOmegaEffect']
        d_alphaomega,GV,AOE
     end
     else: print,'Diagnostic not implemented yet ...'
  endcase
end
        

