pro con_pol_spiffy_mag,b,r,costheta,noborder=noborder, clabels=clabels, $
        title=title,levels=levels,interface=interface,fill=fill,flip=flip,$
        boxsmooth=boxsmooth,r_extra=r_extra,cthick=cthick,cannota=cannota

  ; b = fltarr(N_theta,N_R)
  ; the radial dimension is the second dimension of a.
  ; the definition of theta is such that costheta = 1 at the north pole and 
  ; -1 at the south pole.

  a = b
  if keyword_set(flip) then begin
     sz = size(b) & N_theta = sz(1)  
     for i=0,N_theta-1 do a(i,*) = b(N_theta-1-i,*)
  endif

  szz=size(b) & N_R=szz(2); & print,N_R

  if n_elements(boxsmooth) gt 1 then begin ; boxcar filter
     c = a
     sz=size(a)
     wr = fix(boxsmooth(1)) & wt = fix(boxsmooth(0))
     norm = 1./(2.*wr+1.)*(2.*wt+1.)
     for i=0,sz(1)-1 do begin
         for j=0,sz(2)-1 do begin
             i1 = (i-wt) > 0
             i2 = (i+wt) < sz(1)-1
             j1 = (j-wr) > 0
             j2 = (j+wr) < sz(2)-1
             norm = 1./((i2-i1+1.)*(j2-j1+1.))
             c(i,j) = norm*total(a(i1:i2,j1:j2))
         endfor
     endfor
     a = c
  endif

  if not keyword_set(r_extra) then r_extra=r(N_R/2)
  if not keyword_set(title) then title=' '
  if not keyword_set(levels) then begin
;   levels=min(a) + (findgen(30)+1)*(max(a)-min(a))/29. 
   levels=min(a) + (findgen(20)+1)*(max(a)-min(a))/19. ; original version
;    levels=-6e22 + (findgen(50)+1)/50.*(6e22+6e22) ; test M3
;   levels=min(a) + (findgen(50)+1)*(max(a)-min(a))/50. 
  endif
  if not keyword_set(cthick) then cthick=fltarr(n_elements(levels))+1.

  ; move into a coordinate system where theta=0 corresponds to
  ; the x axis ("latitude")
  sinlat = costheta
  coslat = sqrt(1.0 - sinlat^2)
  x = coslat # r
  y = sinlat # r

  if keyword_set(fill) then begin
;     print,levels(0:1)
      loadct_mld,41 ; 42
      mina=min(a) & maxa=max(a) 
      print,'original min:',mina
; if levels(0) gt 0 then begin ; useful for dipolar seed with only positive levels
;  print,'only positive levels!, so need to symmetrize to get the colors right'
;  levels=-max(a) + (findgen(40)+1)*(max(a)+max(a))/40. ; 25 before
;  mini=0.
; endif else begin
;  mini=levels(0)
; endelse
;     print,'new min: ',mini
;      read,mini
;     sz = size(a) & six = float(sz(1)) & siy = float(sz(2))
;     for i=0,six-1 do begin
;      for j=0,siy-1 do begin
;       if (a(i,j) lt mini) then a(i,j)=mini
;      endfor
;     endfor

      minl=-6e22 & maxl=6e22 ; M3 -6e22,6e22
;scim,a,scale=[minl,maxl],outim=aout,/nowin,/quiet
      aout=bytscl(a,min=minl,max=maxl)

      contour,aout,x,y,xsty=5,ysty=5,lev=levels,title=title,/follow,/fill,c_lin=(levels lt 127)

  endif else begin

      if n_elements(clabels) ne n_elements(levels) then begin
          c_labels=intarr(n_elements(levels))
      endif else begin
          c_labels=clabels
      endelse
;      c_thick=fltarr(n_elements(levels))+1. 
      c_thick=cthick ;& print,c_thick
;;      ind = where(levels eq 0.0)
;;      if ind(0) gt 0 then c_thick(ind(0))=2.0 ; 4.0
      contour,a,x,y,xsty=5,ysty=5,lev=levels,c_lin=(levels lt 0.0),title=title,$
        /follow,c_labels=c_labels,c_thick=c_thick,xr=[0.0,max(x)],c_annotation=cannota

  endelse

  if not keyword_set(noborder) then begin
     pthick=3.0

     rmin = min(r) & rmax=max(r) ;& print,'r_max ',rmax,', r_min ',rmin
     print,r_extra

     xx=rmin*findgen(50)/49.  
     oplot,xx,sqrt(rmin^2-xx^2),thick=pthick 
     oplot,xx,-sqrt(rmin^2-xx^2),thick=pthick
     oplot,[0.,0.],[-rmin,rmin],thick=pthick,line=2
     oplot,[0.,0.],[-r_extra,-rmin],thick=pthick
     oplot,[0.,0.],[rmin,r_extra],thick=pthick
     oplot,[0.,rmin],[0,0],line=2,thick=pthick
;     rmax=r(N_R/2) ; version which was assuming that top is at r_max/2
     xx=r_extra*findgen(100)/99.
     oplot,xx,sqrt(r_extra^2-xx^2),thick=pthick
     oplot,xx,-sqrt(r_extra^2-xx^2),thick=pthick

     if keyword_set(interface) then begin
         xx=interface*findgen(50)/49.
         oplot,xx,sqrt(interface^2-xx^2),line=2,thick=pthick
         oplot,xx,-sqrt(interface^2-xx^2),line=2,thick=pthick
     endif

  endif
  

end


