;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;   driver.pro  -  Integrator of IDL routines
;       usage:     driver,input_file
;     
;  A.S.Brun, Constance and J. Varela - 25/03/2015
;
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

pro driver,driver_input

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;  Input main (Check the sub programs for more information of the internal variables)
;
;  The directory structure must be the next to avoid problems:
;          main directory                          = dir
;           folder for Scalar subprogram           = dir/Scalar (ASH Scalar output)
;           folder for flux_bal subprogram         = dir/SHAV   (ASH Shell_Avgs output)
;           folder for see_az_avgs subprogram      = dir/AZAV   (ASH AZ_Avgs output)
;           folder for see_shell_slices subprogram = dir/SHSL   (ASH Shell_Slices output)
;           folder for see_eq_slices subprogram    = dir/EQSL   (ASH Equatorial_Slices output)
;           folder for psf ouput                   = dir/figs
;                      
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; Read input file if existing 
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

  choice1 = '1' 
  res    = dictionary()

  if (n_params() eq 0) then begin
     print,'No input file'
     print,'==> Analysis parameters will be asked'
     res = dictionary()
     GV=dictionary()
     ans1=''
     print,'Enter case directory'
     read,ans1
     GV['dir']=ans1
     ans1=0.0
     print,'HD or MHD analysis ? (0/1)'
     read,ans1
     GV['hydro']=ans1
;     res['GlobalVariables']=GV
  endif else begin
     if n_params() eq 1 then begin
        if isa(driver_input,/string) eq 1 then begin
           parser,driver_input,res
           GV = res['GlobalVariables']
       endif else begin
           print,'Format input error : input file name has to be a string'
           return
        endelse
     endif else begin
        print,'Input error : too many parameters --> only need input file name'
        return
     endelse
  endelse

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; Print choices
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

  while (choice1 ne '') do begin
     
     print,' '
     print,'******************************'
     print,' Analysis choice '
     print,'******************************'
     print,' '
     print,'* 1  : Flux Balance'
     print,'* 2  : Scalar'
     print,'* 3  : Scalar (zones)'
     print,'* 4  : Shell Averages' 
     print,'* 5  : Equatorial slices'
     print,'* 6  : Equatorial slices movie'
     print,'* 7  : Shell slices'
     print,'* 8  : Shell slices (envision)'
     print,'* 9  : Shell slices movie'
     print,'* 10 : Shell slices movie'
     print,'* 11 : Spectra'
     print,'* 12 : Azimuthal averages'
     print,'* 13 : Mean azimuthal averages'
     print,'* 14 : Azimuthal averages movie'
     print,'* 15 : Butterfly diagram'
     print,'* 16 : Butterfly diagram mean'
     print,'* 17 : Butterfly diagram radial'
     print,'* 18 : Angular momentum'
     print,'* 19 : Magnetic field production'
     print,'* 20 : alpha-omega effect'
     print,' '
     print,'* 0  : change case'
     print,' '
     print,'Which analysis ? : '
     read,choice1
     if choice1 ne '' then begin
        choice,choice1,res,GV
     endif 
  endwhile
  print,'Bye, bye !!'
end 
