pro image_polar_B,a,r,costheta,spacing=spacing,amap=amap,title=title,interface=interface,$
    flip = flip,vmin=vmin,noborder=noborder,levels=levels,c_labels=c_labels,c_thick=c_thick, $
    mini=mini,maxi=maxi,blackline=blackline,rbcz=rbcz,c_linestyle=c_linestyle,r_extra=r_extra

  if keyword_set(flip) then begin
     sz = size(a) & N_theta = sz(1)
     b = a     
     for i=0,N_theta-1 do a(i,*) = b(N_theta-1-i,*)
  endif
; print,N_theta

  theta = !pi*.5 - acos(costheta)

  if not keyword_set(r_extra) then r_extra=0
  rmax = max(r) & rmin = min(r) & print,'in image_polar original rmin/max',rmin,rmax
  if r_extra ne 0 then begin
   rmax2=r_extra*rmax
  endif else begin
   rmax2=rmax
  endelse
  print,'new rmax for sizing issue',rmax2
  rappr=rmax/rmax2

  if not keyword_set(spacing) then spacing = .01*rmax
  if not keyword_set(title) then title = ' '
;;;  if not keyword_set(rbcz) then rbcz=0
;Note: needed to change name variable otherwise rbcz was changed to rbcz*nx in movie_azav.pro too!!!
  if not keyword_set(rbcz) then rbc=0 else rbc=rbcz 

  if keyword_set(vmin) then begin
     amin = vmin
  endif else begin
     amin = min(a)
;;     if amin lt 0.0 then amin = amin*1.15 else amin=amin*.95
  endelse


  ;; modif 09/10/01 , find out that in image_contour mini and maxi
  ; are not taken into account. Thus I decided to modify that: new keywords mini & maxi.

  amap = polar_surface(transpose(a),r,theta,/grid,missing=amin, $
                       bound=[0,-rmax2,rmax2,rmax2],spacing=spacing*[0.2,0.2])

;  print,'in image_polar 3',min(amap),max(amap)

  sz=size(amap) & nx=sz(1) & ny=sz(2)
  x=amap & y=x
  for i=0,ny-1 do x(*,i) = rmax2*findgen(nx)/(nx-1)
  for i=0,nx-1 do y(i,*) = 2.*rmax2*findgen(ny)/(ny-1) - rmax2
  rad = sqrt(x^2+y^2)
  ind=where(rad lt rmin)
  amap(ind) = amin 

;  print,vmin,min(a),max(a)
;  cte_lev=10
;  c_labels=min(a)+findgen(cte_lev)*(max(a)-min(a))/cte_lev
;   levels=360+findgen(cte_lev+3)*10
;   print,levels

;  image_contour,amap,xx=findgen(nx),yy=findgen(ny),title=title,levels=min(amap),/noaxis
  if keyword_set(c_labels) then begin
     image_contour,amap,xx=findgen(nx),yy=findgen(ny),title=title,levels=levels,/noaxis,c_labels=c_labels,c_thick=c_thick,mini=mini,maxi=maxi,blackline=blackline,aspect=1,c_linestyle=c_linestyle
;image_contour,amap,xx=findgen(nx),yy=findgen(ny),title=title,levels=levels,/noaxis,mini=mini,maxi=maxi,blackline=blackline,aspect=1
print,'yoyo'
  endif else begin
  image_contour,amap,xx=findgen(nx),yy=findgen(ny),title=title,levels=min(amap),/noaxis,mini=mini,maxi=maxi,aspect=1 ; original
  if not keyword_set(noborder) then contour,amap,/overplot,nlevels=10
  endelse 

  if not keyword_set(noborder) then begin
     x=findgen(nx)*rappr & y=sqrt((rappr*(nx-1))^2-x^2)
     oplot,x,(nx-1)+y,thick=3 & oplot,x,(nx-1)-y,thick=3
     x2=findgen(nx)*rappr & y2=sqrt((rappr*rmin/rmax*(nx-1))^2-x^2)  ; added this 2 lines on 05/29/2010
 ;;;    oplot,x2,rappr*(nx-1)+y2,thick=3 & oplot,x2,rappr*(nx-1)-y2,thick=3;,color=2

; plot the small ticks every 15 degree
     plots,rappr*(nx-1)*[1,1.025],[nx-1,nx-1],thick=3
     theta_tick=[15,30,45,60,75,90]*2*!pi/360.
     for ii=0,5 do begin
     plots,rappr*(nx-1)*[1,1.025]*cos(theta_tick(ii)),(nx-1)+rappr*(nx-1)*[1,1.025]*sin(theta_tick(ii)),thick=3
     plots,rappr*(nx-1)*[1,1.025]*cos(theta_tick(ii)),(nx-1)+rappr*(nx-1)*[1,1.025]*sin(-1*theta_tick(ii)),thick=3
     endfor     

     x0=x & x0(*)=0 
  ;   oplot,x0,y*1.01,thick=3 & oplot,x0,y+(nx-1),thick=3
     plots,[0,0],[(1-rappr)*(nx-1),(1+rappr)*(nx-1)],thick=3
     y0=x & y0(*)=nx-1 & oplot,x,y0,linestyle=2,thick=3;,color=2
     xyouts,2,(nx-1)+2,'!17 Eq',charthick=1,charsize=1.1;,color=2

; not sure that crap is necessary anymore 05/29/2010 except for bcz dashed line
     cte1=rmin*(nx-1)/rmax*rappr & theta1=!pi*0.5 - theta(0) ;& print,rmin,rmax,cte1,theta(0),theta1
;     oplot,[cte1,nx-1]*sin(theta1),(nx-1)+[cte1,nx-1]*cos(theta1),thick=3;color=2
;     oplot,[cte1,nx-1]*sin(theta1),(nx-1)-[cte1,nx-1]*cos(theta1),thick=3;color=2
;     oplot,[cte1,nx-1]*sin(theta1),rmin*(nx-1)/rmax+[cte1,nx-1]*cos(theta1),thick=3,color=2
;     oplot,[cte1,nx-1]*sin(theta1),rmin*(nx-1)/rmax-[cte1,nx-1]*cos(theta1),thick=3,color=2
     x=x*cte1/100. & y=sqrt(cte1^2-x^2)

;     help,x
     x=rebin(x,3*nx) & y=rebin(y,3*nx)
     theta2=cte1*sin(theta1) ;& print,theta2

;    little loop to find the closest index for x to be equal to theta2 06/08/00
     inda=where(fix(x) eq fix(theta2)) 
;     print,inda & help,inda
     sza=size(inda) ;& print,sza(1)
     if (inda(0) gt 0) then begin 
      indb=inda(0) 
     endif else begin
      print,'check indices in image_polar.pro'
      indb=0
     endelse
      diff=abs(x(indb)-theta2)
     for i=0,sza(1)-1 do begin
      diff1=abs(x(inda(i))-theta2)
      if (diff1 le diff) then begin
        diff=diff1 & indb=inda(i)
      endif
     endfor
;    print,indb

     oplot,x(indb:3*nx-1),(nx-1)+y(indb:3*nx-1),thick=3;,color=2  ; indices originaux 23 va avec 9 & 118
     oplot,x(indb:3*nx-1),(nx-1)-y(indb:3*nx-1),thick=3;,color=2

;cf idn & idx in see_azavgs_sax.pro
;    oplot,x(19:nx-1),(nx-1)+y(19:nx-1),thick=3,color=2 
;    oplot,x(19:nx-1),(nx-1)-y(19:nx-1),thick=3,color=2

     rbc=rbc*(nx-1)*rappr
     ;print,'in image polar, rbcz',rbc
     if (rbc ne 0) then begin
         x=findgen(nx) & indmm=fix(rbc*sin(theta2*!pi/180.0))
         oplot,x(indmm:nx-1),(nx-1)+sqrt(rbc^2-x(indmm:nx-1)^2),line=2,thick=3
         oplot,x(indmm:nx-1),(nx-1)-sqrt(rbc^2-x(indmm:nx-1)^2),line=2,thick=3
        ; oplot,x,(nx-1)+sqrt(rbc^2-x^2),line=2,thick=3
        ; oplot,x,(nx-1)-sqrt(rbc^2-x^2),line=2,thick=3
     endif

     if keyword_set(interface) then begin
         xx=interface*findgen(50)/49.
         oplot,xx,sqrt(interface^2-xx^2),line=2,thick=2
         oplot,xx,-sqrt(interface^2-xx^2),line=2,thick=2
     endif

  endif   
 
; old version   
;   if keyword_set(interface) then begin
;      dr = .5*(1 - interface/rmax)
;      xx=(1-2*dr)*dindgen(200)/199. & yy = xx
;      yy = ((1-2*dr)^2-xx^2)/4
;      ind=where(yy le 1.e-10) 
;      if (ind(0) ge 0) then yy(ind) = 0.0d0
;      oplot,nx*xx,ny*(.5 + sqrt(yy)),col=0,line=2
;      oplot,nx*xx,ny*(.5 - sqrt(yy)),col=0,line=2
;   endif

return

end








