

function legendre_collocation_pts, ntheta
    meps=(machar(/double)).machep
    weights = dblarr(ntheta)
    for n=0L,ntheta/2-1L do begin
        guess = cos(!dpi*(n+0.75d0)/(double(ntheta)+0.5d0))
        old_guess = -2d0
        while (abs(guess-old_guess) gt meps) do begin
            p1 = 1d0
            p2 = 0d0
            for il=1L,ntheta-1 do begin
                p3=p2
                p2=p1
                dil = double(il)
                p1 = ((2d0*dil-1d0)*guess*p2-(dil-1d0)*p3)/dil
            end
            pderiv=ntheta*(guess*p1-p2)/(guess^2-1d0)
            old_guess = guess
            guess = guess-p1/pderiv
        endwhile
        pderiv=ntheta*(guess*p1-p2)/(guess^2-1d0)
        weights[n] = 1d0/(pderiv^2*(1d0-guess^2))
        print, n, ' of', ntheta/2
    endfor
    weights[ntheta/2:*] = reverse(weights[0:ntheta/2-1])
end
