;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;
;  loadct_mld.pro - This procedure is similar to loadct, except that it can
;                   accommodate other color tables higher than index 40 as
;                   well as ANA color tables
;
;  usage:  loadct_mld,index,/ana
;       where index = color table index, 0-40 load the usual IDL color tables,
;                     while index>40 load user-specified color tables
;             ana = set flag if ANA color tables are to be loaded rather than
;             IDL color tables
;
;  notes: - The user-specified color tables must have index-specific
;           filenames, e.g. ct41.bin for color table #41.
;
;  M.DeRosa - 25 Oct 1999 - created
;
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

pro loadct_mld,index,ana=ana

if keyword_set(ana) then tvlct,get_ana_ctab(index) $
else begin
  if index le 40 then loadct,index else begin
    openr,lun,'./ctbin/ct'+strtrim(fix(index(0)),2)+'.bin',/g
    ctab=bytarr(256,3)
    readu,lun,ctab
    free_lun,lun
    tvlct,ctab
  endelse
endelse

end
