pro movie_strl_mag_sun12,fill=fill,swap=swap,extrapol=extrapol

if not keyword_set(extrapol) then extrapol=0

;loadct_mld,41
window,0,xs=800,ys=640
name='Bp_PenDMag'
if not keyword_set(fill) then fill=0
if not keyword_set(swap) then swap=0

interface1=0.74;0.5 ;(i.e 2.5e10 vs 5e10); use normalized radius r1d instead of r1c

daysflag=1

;n=268 ;1 ; 192
;file=strarr(n) ; 365500 -> 499500 n=268
;k=365500
;for i=0,n-1 do begin
;file(i)=strtrim(string(k,format='(i6)'),2)
;k=k+500
;endfor

dir='/home/soleilprojets/ASH/Brun/PenDMag/'
;file=['61000','65000','70000','75000','80000','85000','90000','95000','100000','105000','110000','115000','120000','125000','130000','135000','140000','145000','150000','155000','160000','165000','170000','175000','180000','185000','190000','195000','200000','205000','210000']
;file=['61000'] ;,'65000']
file=['210000']

nfiles=n_elements(file) & print,nfiles
nt=intarr(nfiles)

file=dir+'azav_0'+file
;file=dir+file
nt(*)=1 ;10 ;5

nframes = total(nt) & print,'nb of frames',nframes
;------------------------------------------------------------

;  associate data file

temp=0.0
close,1 & openu,1,file(0),swap_endian=swap
readu,1,temp  &  N_R1 = fix(temp)
readu,1,temp  &  N_Theta1 = fix(temp)
readu,1,temp  &  N_Avgs = fix(temp)  ;  N_q in the code
readu,1,temp  &  N_R_CZ = fix(temp)  ;  N_R_1 in the code
az_avgs = assoc(1,fltarr(N_theta1,N_R1,N_Avgs+1,1))

;  read in r,theta indices, quantity codes

radius = fltarr(n_r1)
radius(N_R1-1) = az_avgs(7,0,0,0,0)  ;  inner radius
radius(0) = az_avgs(9,0,0,0,0)  ; outer radius
radius(1:N_R1-2) = az_avgs(10,0:N_R1-3,0,0,0)
costheta = reform(az_avgs(*,N_R1-2,0,0,0))
sintheta = reform(az_avgs(*,N_R1-1,0,0,0))
lat=90.-acos(costheta)*!radeg

quantities = fix(reform(az_avgs(11,0:N_Avgs-1,0,0,0)))
to = az_avgs(5,0,0,0,0)
if (daysflag eq 1) then to=to/(3600.*24d0)
print,'initial time',to

close,1
q1=where(quantities eq 61) & q2=where(quantities eq 62)
q1=q1+1 & q2=q2+1

r1=radius & ct1=costheta
r1b=dblarr(N_R1) & r1c=dblarr(2*N_R1) & aa=1.5d0
r1b=r1(0)*(1.0+aa*findgen(N_R1)/(N_R1-1))

for i=N_R1,2*N_R1-1 do r1c(i)=r1b(i-N_R1)
for i=0,N_R1-1 do r1c(N_R1-1-i)=r1(i)
r1d=r1c/r1(0)
theta1=acos(ct1)
;print,theta1

single=0
if single eq 1 then begin
r1x=r1/r1(0) & ifile=0 & it=0
close,1 & openu,1,file(ifile),swap_endian=swap
az_avgs = assoc(1,fltarr(N_theta1,N_R1,N_Avgs+1,1))
Vr1=reform(az_avgs(*,*,q1,0,it))
vtheta1=reform(az_avgs(*,*,q2,0,it))
title1 = get_name12(quantities(q1-1))
title2 = get_name12(quantities(q2-1))
print,title1,', ',title2
psi1x=streamfunction(Vr1,Vtheta1,r1x,ct1)
print,min(psi1x),max(psi1x)
;levs=(findgen(60)+1)*255/60

xs=4.0 & ys=3.8
!p.multi=[0,2,1]

!p.thick=2.0
!p.charthick=1.0
xyouts,0,0,'!17'

y1 = .02 & y2 = .98
x1 = .02 & x4 = .98

dy = y2-y1
dx = 0.5*dy * (ys/xs)
;dx = 0.5*dy
x2 = x1+dx & x3 = x4-dx

!p.position=[x1,y1,x2,y2]
;!p.position=[x1,y1,x2,dy]

con_pol_spiffy_mag14,psi1x(*,0:N_R1-1),r1x(0:N_R1-1),ct1,inter=interface1,fill=fill,r_extra=1;,levels=levs
stop
endif ; single


levs=[-250.0,-100,-50.0,-25.0,-10.0,-5.0,-2.5,-1.0,-0.5,-0.1,-0.01,-0.001,0.001,0.01,0.1,0.5,1.0,2.5,5.0,10.0,25.0,50.0,100.0,250.0]

ind = 0 & idn=0 & idx=N_theta1-1
q3=3
title3 = get_name14(quantities(q3-1)) & print,title3

for ifile=0,nfiles-1 do begin

    close,1 & openu,1,file(ifile),swap_endian=swap
az_avgs = assoc(1,fltarr(N_theta1,N_R1,N_Avgs+1,1))

for it = 0,nt(ifile)-1 do begin

iteration  = az_avgs(4,0,0,0,it) 
time       = az_avgs(5,0,0,0,it)
deltat     = az_avgs(6,0,0,0,it)
if (daysflag eq 1) then time=time/(3600.*24d0)
print,'  iteration = ',strtrim(iteration,2),$
      ', time = '   ,strtrim(time-to ,2),$
      ', delta t = ',strtrim(deltat   ,2)

print,'frame number: ',ind
Vr1=reform(az_avgs(*,*,q1,0,it))
vtheta1=reform(az_avgs(*,*,q2,0,it))

title1 = get_name12(quantities(q1))
title2 = get_name12(quantities(q2))
print,title1,', ',title2
;------------------------------------------------------------

; modified version assumed the mag field array contain external field as well
if extrapol eq 0 then begin
 Mr1 = fltarr(N_Theta1,N_R1) & Mtheta1=Mr1
 Mr1=Vr1 & Mtheta1=Vtheta1 & r1d=r1/r1(0)
endif else begin
 Mr1 = fltarr(N_Theta1,2*N_R1) & Mtheta1=Mr1
 Vr1_in=Vr1(*,*) & Vtheta1_in=Vtheta1(*,*)
 Vr1=Mr1 & Vtheta1=Mr1
endelse

if extrapol eq 1 then begin
; be careful index for 0,N_R1-1 -> Rsurf,Rbot so we need to reverse it
for i=0,N_R1-1 do begin
 Vr1(*,i)=Vr1_in(*,N_R1-1-i)
 Vtheta1(*,i)=Vtheta1_in(*,N_R1-1-i)
endfor

; ok now Vr1 as 2nd index and r in the same sense, i.e 0,N_r-1 -> r=Rbot,Rsurf

; Then we need to get the a[]'s from the curve fitting corresponding to Br(*,rtop)
Brtop1=double(Vr1(*,N_R1-1)) 

M=10 ;N_theta1*2./3.0 ; 20 
coeff = SVDFIT(ct1,Brtop1,M,chisq=chi1b,/double,/legendre,y=ytest); func='flegendre')
print,'chi: ',chi1b
;print,coeff,chi1b
;stop

Vr1(*,N_R1:2*N_R1-1)=0.0 & Vtheta1(*,N_R1:2*N_R1-1)=0.0

for l=1,M-2 do begin
 ell=double(l) ;& print,ell
 Rl=ell/sqrt(4.d0*ell^2.d0-1.d0) & Rlp1=double(l+1.d0)/sqrt(4.d0*double(l+1.d0)^2.d0-1.d0)
 plend=legendre(ct1,l)  ;der_p=deriv(theta1,plend)

 rtp1=r1d(N_R1-1)^(ell-1.d0) & rtp2=r1d(N_R1-1)^(-(ell+2.d0)) & rss1=r1d(2*N_R1-1)^(-(2.d0*ell+1.d0))
 rtpm1=r1d(N_R1-1)^(ell-2.d0) & rtpm2=r1d(N_R1-1)^(-(ell+1.d0)) & rssm1=r1d(2*N_R1-1)^(-(2.d0*ell-1.d0))
 rtpp1=r1d(N_R1-1)^ell & rtpp2=r1d(N_R1-1)^(-(ell+3.d0)) & rssp1=r1d(2*N_R1-1)^(-(2.d0*ell+3.d0))

 Blm=coeff(l)/(ell*rss1*rtp1+(ell+1.d0)*rtp2)
 Alm=-Blm*rss1
 Blmp1=coeff(l+1)/((ell+1.d0)*rssp1*rtpp1+(ell+2.d0)*rtpp2)
 Almp1=-Blmp1*rssp1
 Blmm1=coeff(l-1)/((ell-1.d0)*rssm1*rtpm1+ell*rtpm2)
 Almm1=-Blmm1*rssm1

 ;print,Blm,Alm,Blmp1,Almp1,Blmm1,Almm1
 ; if source term at rs=rtop from surf, plotting pb!, 2.5 rtop ok
  Alm=0.d0 & Almm1=0.d0 & Almp1=0.d0 ; no source term when Alm's=0 

  for i=0,N_theta1-1 do begin
   for j=N_R1,2*N_R1-1 do begin                       
    Vr1(i,j)=Vr1(i,j)-(Alm*ell*r1d(j)^(ell-1.d0)-Blm*(ell+1.d0)/r1d(j)^(ell+2.d0))*plend(i) 
    Vtheta1(i,j)=Vtheta1(i,j)+Rl*(ell-1.d0)*(Almm1*r1d(j)^(ell-1.d0)+Blmm1/r1d(j)^ell)
    Vtheta1(i,j)=Vtheta1(i,j)-Rlp1*(ell+2.d0)*(Almp1*r1d(j)^(ell+1.d0)+Blmp1/r1d(j)^(ell+2.d0))
    Vtheta1(i,j)=-Vtheta1(i,j)*plend(i)/r1d(j)/sin(theta1(i))
   endfor
  endfor 
endfor

for i=0,2*N_R1-1 do begin
    Mr1(*,i) = Vr1(*,i)
    Mtheta1(*,i) = Vtheta1(*,i)
endfor

endif ; extrapol

psi1=streamfunction14(Mr1,Mtheta1,r1d,ct1)

print,min(psi1),max(psi1)
;-----------------------------------------
xs=4.0 & ys=3.8
!p.multi=[0,2,1]

;set_plot,'ps'
;device,xs=xs,ys=ys,/inches,file='streamlines.ps',/encapsulated

!p.thick=2.0
!p.charthick=1.0
xyouts,0,0,'!17'

y1 = .02 & y2 = .98
x1 = .02 & x4 = .98

dy = y2-y1
;dx = 0.5*dy * (ys/xs)
dx = 0.5*dy
x2 = x1+dx & x3 = x4-dx

;!p.position=[x1,y1,x2,y2]
!p.position=[x1,y1,x2,dy]

;if fill eq 1 then begin
;!p.position=[x1,y1,x2*0.8,dy]
;endif else if psf eq 1 then begin
;!p.position=[x1,y1,x2,dy*0.99]
;endif else begin
!p.position=[x1,y1,x2*0.8,dy]
;endelse

Global_rate=2.6d-6
Vphi=reform(az_avgs(*,*,q3,0,it))
if q3 eq 3 then begin
for i=0,N_R1-1 do begin
  Vphi(*,i)=Vphi(*,i)/radius(i)/sin(acos(costheta(*)))+Global_rate
endfor
vphi=vphi/2./!pi*1e9 ; s^-1 -> nHz
endif

   if ind eq 0 then begin
    minil=min(vphi) & maxil=max(vphi)
    print,'mini, maxi',minil,maxil
    ans1=0
    print,' '
    print,'Do you want to keep these min and max values (0/1)?',minil,maxil
    read,ans1
    if (ans1 eq 1) then begin
    print,'enter new values, min first'
    read,minil,maxil
    endif
  
    c_labels=[1,1,1]
    if q3 eq 3 then begin
     levels=300+findgen(17)*10
     levels(11)=fix(Global_rate/2./!pi*1e9)
    endif else begin
     levels=[-5000,-2500,-1000,-500,-250,-100,100,250,500,1000,2500,5000]
    endelse
  endif ; ind

if extrapol eq 1 then begin
raprr=1.0+aa
image_polar,vphi(idn:idx,*),radius,costheta(idn:idx),sp=sp,mini=minil,maxi=maxil,levels=levels,c_labels=c_labels,r_bcz=r_bcz,r_extra=raprr;,/noborder
con_pol_spiffy_mag14,psi1(*,0:2*N_R1-2),r1d(0:2*N_R1-2),ct1,inter=interface1,fill=fill,levels=levs;,title='Poloidal Field B'
endif else begin
image_polar,vphi(idn:idx,*),radius,costheta(idn:idx),sp=sp,mini=minil,maxi=maxil,levels=levels,c_labels=c_labels,r_bcz=r_bcz;,/noborder
con_pol_spiffy_mag14,psi1(*,0:N_R1-2),r1d(0:N_R1-2),ct1,inter=interface1,fill=fill,r_extra=1.0,levels=levs;,title='Poloidal Field B'
endelse

;;xyouts,x1+0.015,(y2-y1)/2.*1.05,'Eq.',/normal,align=0.5,charsize=1.3
;xyouts,(x4-x1)/4.,0.02,'Case M3, t= '+strtrim(string(time-to,format='(g10.4)'),2)+' days',/normal,align=0.5
xyouts,(x4-x1)/4.,0.02,'Case PenDMag, t= '+strtrim(string(time-to,format='(g10.4)'),2)+' days',/normal,align=0.5

;xx=.12 & yy=.55
;xyouts,x1+xx,yy,'initial B!D0!N',/normal,align=0.5

;xx=.35 & yy=.07
;xyouts,x1+xx,yy,'!8a!17',/normal,chars=1.0
;xyouts,x3+xx,yy,'!8b!17',/normal,chars=1.0

;device,/close
;set_plot,'x'
;------------------------------------------------------------

stop

tvlct,r,g,b,/get
image_azav=tvrd()

if (nframes le 99) then begin
 if (ind lt 10) then name1=name+'0'+strcompress(ind,/r)+'.bmp' $
                else name1=name+strcompress(ind,/r)+'.bmp'
endif else if (nframes le 999) Then begin
 if (ind lt 10) then begin
  name1=name+'00'+strcompress(ind,/r)+'.bmp' 
 endif else if (ind lt 100) then begin 
  name1=name+'0'+strcompress(ind,/r)+'.bmp'
 endif else begin
  name1=name+strcompress(ind,/r)+'.bmp
 endelse
endif else begin
 if (ind lt 10) then begin
  name1=name+'000'+strcompress(ind,/r)+'.bmp'  
 endif else if (ind lt 100) then begin 
  name1=name+'00'+strcompress(ind,/r)+'.bmp'
 endif else if (ind lt 1000) then begin 
  name1=name+'0'+strcompress(ind,/r)+'.bmp'
 endif else begin
  name1=name+strcompress(ind,/r)+'.bmp
 endelse
endelse

write_bmp,name1,image_azav,r,g,b  ;bytscl(image_azav,max=255)
;write_pict,name1,image_azav,r,g,b

ind = ind + 1

endfor ; it
endfor ; ifiles

!p.multi=0
!p.position=0

end









