@get_names
pro movie_strl_mag_bp,fill=fill,swap=swap,psf=psf,extrapol=extrapol

window,0,xs=800,ys=640
name='Bp_Test'
if not keyword_set(fill) then fill=0
if not keyword_set(swap) then swap=0
if not keyword_set(psf) then psf=0
if not keyword_set(extrapol) then extrapol=0  ; if extrapol = 1, check imagepolar rmax to get correct sizing between contour plot and lines

interface1=0 ;0.5 ;(i.e 2.5e10 vs 5e10); use normalized radius r1d instead of r1c

rbcz=0.2 ;0.73

daysflag=1

dir='/dsm/stars2/f/cemeriau/EvolZR/20_eta_3d12/AZAV/'
file=['1074000']

nfiles=n_elements(file) & print,nfiles
nt=intarr(nfiles)

file=dir+'azav_0'+file
nt(*)=1 ;10 ;5

nframes = total(nt) & print,'nb of frames',nframes

device,decomposed=0

;------------------------------------------------------------

;  associate data file

temp=0.0
close,1 & openu,1,file(0),swap_endian=swap
readu,1,temp  &  N_R1 = fix(temp)
readu,1,temp  &  N_Theta1 = fix(temp)
readu,1,temp  &  N_Avgs = fix(temp)  ;  N_q in the code
readu,1,temp  &  N_R_CZ = fix(temp)  ;  N_R_1 in the code
az_avgs = assoc(1,fltarr(N_theta1,N_R1,N_Avgs+1,1))

;  read in r,theta indices, quantity codes

radius = fltarr(n_r1)
radius(N_R1-1) = az_avgs(7,0,0,0,0)  ;  inner radius
radius(0) = az_avgs(9,0,0,0,0)  ; outer radius
radius(1:N_R1-2) = az_avgs(10,0:N_R1-3,0,0,0)
costheta = reform(az_avgs(*,N_R1-2,0,0,0))
sintheta = reform(az_avgs(*,N_R1-1,0,0,0))
lat=90.-acos(costheta)*!radeg

quantities = fix(reform(az_avgs(11,0:N_Avgs-1,0,0,0)))
to = az_avgs(5,0,0,0,0)
if (daysflag eq 1) then to=to/(3600.*24d0)
print,'initial time',to

close,1
q1=where(quantities eq 61) & q2=where(quantities eq 62)
q1=q1+1 & q2=q2+1
;print,q1,q2
title1 = get_name2(quantities(q1-1))
title2 = get_name2(quantities(q2-1))
print,title1,', ',title2

r1=radius & ct1=costheta
r1b=dblarr(N_R1) & r1c=dblarr(2*N_R1) & aa=1.5d0
r1b=r1(0)*(1.0+aa*findgen(N_R1)/(N_R1-1))

for i=N_R1,2*N_R1-1 do r1c(i)=r1b(i-N_R1)
for i=0,N_R1-1 do r1c(N_R1-1-i)=r1(i)
r1d=r1c/r1(0)
theta1=acos(ct1)
;print,theta1

factt=1e0 ; multiplying factor
single=0
if single eq 1 then begin
r1x=r1/r1(0) & ifile=0 & it=0
close,1 & openu,1,file(ifile),swap_endian=swap
az_avgs = assoc(1,fltarr(N_theta1,N_R1,N_Avgs+1,1))
Vr1=reform(az_avgs(*,*,q1,0,it))
vtheta1=reform(az_avgs(*,*,q2,0,it))

Mr1x = fltarr(N_Theta1,N_R1) & Mtheta1x=Mr1x
for i=0,N_R1-1 do begin
    Mr1x(*,i) = factt*Vr1(*,i,2)
    Mtheta1x(*,i) = factt*Vtheta1(*,i,2)
endfor
psi1x=streamfunction(Mr1x,Mtheta1x,r1x,ct1)
;print,min(psi1x),max(psi1x)

xs=4.0 & ys=3.8
!p.multi=[0,2,1]

!p.thick=2.0
!p.charthick=1.0
xyouts,0,0,'!17'

y1 = .02 & y2 = .98
x1 = .02 & x4 = .98

dy = y2-y1
dx = 0.5*dy * (ys/xs)
;dx = 0.5*dy
x2 = x1+dx & x3 = x4-dx

!p.position=[x1,y1,x2,y2]
;!p.position=[x1,y1,x2,dy]

con_pol_spiffy_mag,psi1x(*,0:N_R1-1),r1x(0:N_R1-1),ct1,inter=interface1,fill=fill,r_extra=1;,levels=levs
stop
endif ; single

;levs=[-20.0,-17.5,-15.0,-12.5,-10.0,-8.0,-5.0,-4.0,-3.0,-2.0,-1.0,-0.5,-0.1,0.1,0.5,1.0,2.0,3.0,4.0,5.0,8.0,10.0,12.5,15.0,17.5,20.0]
levs=[-250.0,-100,-50.0,-25.0,-10.0,-5.0,-2.5,-1.0,-0.5,-0.1,-0.01,-0.001,0.001,0.01,0.1,0.5,1.0,2.5,5.0,10.0,25.0,50.0,100.0,250.0]

ind = 0 & idn=0 & idx=N_theta1-1

q3=where(quantities eq 63) & q3=q3+1
title3 = get_name2(quantities(q3-1)) & print,title3

for ifile=0,nfiles-1 do begin

close,1 & openu,1,file(ifile),swap_endian=swap
az_avgs = assoc(1,fltarr(N_theta1,N_R1,N_Avgs+1,1))

for it = 0,nt(ifile)-1 do begin

iteration  = az_avgs(4,0,0,0,it) 
time       = az_avgs(5,0,0,0,it)
deltat     = az_avgs(6,0,0,0,it)
if (daysflag eq 1) then time=time/(3600.*24d0)
print,'  iteration = ',strtrim(iteration,2),$
      ', time = '   ,strtrim(time-to ,2),$
      ', delta t = ',strtrim(deltat   ,2)

print,'frame number: ',ind
Vr1=reform(az_avgs(*,*,q1,0,it))
vtheta1=reform(az_avgs(*,*,q2,0,it))

title1 = get_name2(quantities(q1-1))
title2 = get_name2(quantities(q2-1))
print,title1,', ',title2
;------------------------------------------------------------

; modified version assumed the mag field array contain external field as well
;extrapol=0 ;1 ;0 ; now an argument
if extrapol eq 0 then begin
 Mr1 = fltarr(N_Theta1,N_R1) & Mtheta1=Mr1
 Mr1=factt*Vr1 & Mtheta1=factt*Vtheta1 & r1d=r1/r1(0)
endif else begin
 Mr1 = fltarr(N_Theta1,2*N_R1) & Mtheta1=Mr1
 Vr1_in=factt*Vr1(*,*) & Vtheta1_in=factt*Vtheta1(*,*)
 Vr1=Mr1 & Vtheta1=Mr1
endelse

if extrapol eq 1 then begin
; be careful index for 0,N_R1-1 -> Rsurf,Rbot so we need to reverse it
for i=0,N_R1-1 do begin
 Vr1(*,i)=Vr1_in(*,N_R1-1-i)
 Vtheta1(*,i)=Vtheta1_in(*,N_R1-1-i)
endfor

; ok now Vr1 as 2nd index and r in the same sense, i.e 0,N_r-1 -> r=Rbot,Rsurf

; Then we need to get the a[]'s from the curve fitting corresponding to Br(*,rtop)
Brtop1=double(Vr1(*,N_R1-1)) 

M=20 ;20 ;100 ;20 ;200 ;86 ;180
coeff = SVDFIT(ct1,Brtop1,M,chisq=chi1b,/double,/legendre,y=ytest); func='flegendre')
print,'chi: ',chi1b
;print,coeff,chi1b
;stop

Vr1(*,N_R1:2*N_R1-1)=0.0 & Vtheta1(*,N_R1:2*N_R1-1)=0.0

for l=1,M-2 do begin
 ell=double(l) ;& print,ell
 Rl=ell/sqrt(4.d0*ell^2.d0-1.d0) & Rlp1=double(l+1.d0)/sqrt(4.d0*double(l+1.d0)^2.d0-1.d0)
 plend=legendre(ct1,l)  ;der_p=deriv(theta1,plend)

 rtp1=r1d(N_R1-1)^(ell-1.d0) & rtp2=r1d(N_R1-1)^(-(ell+2.d0)) & rss1=r1d(2*N_R1-1)^(-(2.d0*ell+1.d0))
 rtpm1=r1d(N_R1-1)^(ell-2.d0) & rtpm2=r1d(N_R1-1)^(-(ell+1.d0)) & rssm1=r1d(2*N_R1-1)^(-(2.d0*ell-1.d0))
 rtpp1=r1d(N_R1-1)^ell & rtpp2=r1d(N_R1-1)^(-(ell+3.d0)) & rssp1=r1d(2*N_R1-1)^(-(2.d0*ell+3.d0))

 Blm=coeff(l)/(ell*rss1*rtp1+(ell+1.d0)*rtp2)
 Alm=-Blm*rss1
 Blmp1=coeff(l+1)/((ell+1.d0)*rssp1*rtpp1+(ell+2.d0)*rtpp2)
 Almp1=-Blmp1*rssp1
 Blmm1=coeff(l-1)/((ell-1.d0)*rssm1*rtpm1+ell*rtpm2)
 Almm1=-Blmm1*rssm1

 ;print,Blm,Alm,Blmp1,Almp1,Blmm1,Almm1
 ; if source term at rs=rtop from surf, plotting pb!, 2.5 rtop ok
  Alm=0.d0 & Almm1=0.d0 & Almp1=0.d0 ; no source term when Alm's=0 

  for i=0,N_theta1-1 do begin
   for j=N_R1,2*N_R1-1 do begin                       
    Vr1(i,j)=Vr1(i,j)-(Alm*ell*r1d(j)^(ell-1.d0)-Blm*(ell+1.d0)/r1d(j)^(ell+2.d0))*plend(i) 
    Vtheta1(i,j)=Vtheta1(i,j)+Rl*(ell-1.d0)*(Almm1*r1d(j)^(ell-1.d0)+Blmm1/r1d(j)^ell)
    Vtheta1(i,j)=Vtheta1(i,j)-Rlp1*(ell+2.d0)*(Almp1*r1d(j)^(ell+1.d0)+Blmp1/r1d(j)^(ell+2.d0))
    Vtheta1(i,j)=-Vtheta1(i,j)*plend(i)/r1d(j)/sin(theta1(i))
   endfor
  endfor 
endfor

for i=0,2*N_R1-1 do begin
    Mr1(*,i) = Vr1(*,i)
    Mtheta1(*,i) = Vtheta1(*,i)
endfor

endif ; extrapol

psi1=streamfunction(Mr1,Mtheta1,r1d,ct1)

print,min(psi1),max(psi1)
;levs=get_contour_levels(psi1,nlevs,mn=mnv,mx=mxv,pct=0.04)
;help,psi1
;levs=(findgen(40)+1)*(255)/40

;solid countour denote vorticity out of the page;;
;psi1 = -psi1
;-----------------------------------------
xs=4.0 & ys=3.8
!p.multi=[0,2,1]

;set_plot,'ps'
;device,xs=xs,ys=ys,/inches,file='streamlines.ps',/encapsulated

if psf eq 1 then set_plot,'ps'

;------------------------------------------------------------

if ((fill eq 1) and (psf ne 1)) then begin

;tvlct,r,g,b,/get
;image_azav=tvrd()

if (nframes le 99) then begin
 if (ind lt 10) then name1=name+'0'+strcompress(ind,/r)+'.bmp' $
                else name1=name+strcompress(ind,/r)+'.bmp'
endif else if (nframes le 999) Then begin
 if (ind lt 10) then begin
  name1=name+'00'+strcompress(ind,/r)+'.bmp' 
 endif else if (ind lt 100) then begin 
  name1=name+'0'+strcompress(ind,/r)+'.bmp'
 endif else begin
  name1=name+strcompress(ind,/r)+'.bmp'
 endelse
endif else begin
 if (ind lt 10) then begin
  name1=name+'000'+strcompress(ind,/r)+'.bmp'  
 endif else if (ind lt 100) then begin 
  name1=name+'00'+strcompress(ind,/r)+'.bmp'
 endif else if (ind lt 1000) then begin 
  name1=name+'0'+strcompress(ind,/r)+'.bmp'
 endif else begin
  name1=name+strcompress(ind,/r)+'.bmp'
 endelse
endelse

endif else if psf eq 1 then begin

if (nframes le 99) then begin
 if (ind lt 10) then name1=name+'0'+strcompress(ind,/r)+'.ps' $
                else name1=name+strcompress(ind,/r)+'.ps'
endif else if (nframes le 999) Then begin
 if (ind lt 10) then begin
  name1=name+'00'+strcompress(ind,/r)+'.ps' 
 endif else if (ind lt 100) then begin 
  name1=name+'0'+strcompress(ind,/r)+'.ps'
 endif else begin
  name1=name+strcompress(ind,/r)+'.ps'
 endelse
endif else begin
 if (ind lt 10) then begin
  name1=name+'000'+strcompress(ind,/r)+'.ps'  
 endif else if (ind lt 100) then begin 
  name1=name+'00'+strcompress(ind,/r)+'.ps'
 endif else if (ind lt 1000) then begin 
  name1=name+'0'+strcompress(ind,/r)+'.ps'
 endif else begin
  name1=name+strcompress(ind,/r)+'.ps'
 endelse
endelse

device,filename=name1,/color,bits=8,xs=17.5,ys=18,yoffset=1

endif

!p.thick=2.0
!p.charthick=1.0
xyouts,0,0,'!17'

y1 = .02 & y2 = .98
x1 = .02 & x4 = .98

dy = y2-y1
;dx = 0.5*dy * (ys/xs)
dx = 0.5*dy
x2 = x1+dx & x3 = x4-dx

;!p.position=[x1,y1,x2,y2]
!p.position=[x1,y1,x2,dy]

Global_rate=2.6d-6
Vphi=reform(az_avgs(*,*,q3,0,it))
if q3 eq 3 then begin
for i=0,N_R1-1 do begin
  Vphi(*,i)=Vphi(*,i)/radius(i)/sin(acos(costheta(*)))+Global_rate
endfor
vphi=vphi/2./!pi*1e9 ; s^-1 -> nHz
endif

   if ind eq 0 then begin
    minil=min(vphi) & maxil=max(vphi)
    print,'mini, maxi',minil,maxil
    ans1=0
    print,' '
    print,'Do you want to keep these min and max values (0/1)?',minil,maxil
    read,ans1
    if (ans1 eq 1) then begin
    print,'enter new values, min first'
    read,minil,maxil
    endif
  
    if q3 eq 3 then begin
     levels=350+findgen(30)*5 ; 300 with 17 index implies index 14
     levels(13)=fix(Global_rate/2./!pi*1e9)
    c_labels1 = levels*0.0 
    c_labels1(13)=1 
    c_labels1(16)=1
    c_labels1(19)=1
    c_labels1(22)=1
    c_labels1(10)=1
    c_labels1(7)=1
    c_labels1(4)=1
    ;c_thick=[1,1]
    ; print,levels
    endif else begin
     levels=[-5000,-2500,-1000,-500,-250,-100,100,250,500,1000,2500,5000]
     c_labels1=levels*0.0
    endelse
  endif ; ind

loadct_mld,41

if extrapol eq 1 then begin
   print,max(r1c),max(radius)/max(r1c)
   factt=max(radius)/max(r1c)
;stop
   image_polar_B,vphi(idn:idx,*),radius,costheta(idn:idx),sp=sp,mini=minil,maxi=maxil,rbcz=rbcz,levels=levels,c_thick=c_thick,c_labels=c_labels1,r_extra=2.5
endif else begin
   image_polar_B,vphi(idn:idx,*),radius,costheta(idn:idx),sp=sp,mini=minil,maxi=maxil,rbcz=rbcz,levels=levels,c_thick=c_thick,c_labels=c_labels1 ;,/noborder
endelse
;endelse

if fill eq 1 then begin
!p.position=[x1,y1,x2*0.8,dy]
endif else if psf eq 1 then begin
!p.position=[x1,y1,x2,dy*0.99]
endif else begin
!p.position=[x1,y1,x2*0.8,dy]
endelse

if extrapol eq 1 then begin
   con_pol_spiffy_mag,psi1(*,0:2*N_R1-2),r1d(0:2*N_R1-2),ct1,inter=interface1,fill=0,levels=levs,/noborder ;,title='Poloidal Field B'
endif else begin
   con_pol_spiffy_mag,psi1(*,0:N_R1-2),r1d(0:N_R1-2),ct1,inter=interface1,fill=0,r_extra=1.0,levels=levs,/noborder ;,clabels=clabels;,title='Poloidal Field B'
endelse

if fill eq 1 then begin
   xyouts,(x4-x1)/4.,0.02,'Rad Dynamo Case, t= '+strtrim(string(time-to,format='(g10.4)'),2)+' days',/normal,align=0.5
endif else if psf eq 1 then begin
   to=0.0 & print,'attention mis to a 0'
   xyouts,(x4-x1)/3.,0.01,'Antoine s Tacho Case, t= '+strtrim(string(time-to,format='(g10.4)'),2)+' d',/normal,align=0.5
endif

ind = ind + 1

if ((fill eq 1) and (psf ne 1)) then begin
 tvlct,r,g,b,/get
 image_azav=tvrd()
 write_bmp,name1,image_azav,r,g,b  ;bytscl(image_azav,max=255)
endif else if psf eq 1 then begin
 device,/close
endif

endfor ; it
endfor ; ifiles

if psf eq 1 then begin
set_plot,'x'
endif

!p.multi=0
!p.position=0

stop

end









