;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;  Routines : 
;      
;      - d_eqsl     : see_eqsl2
;      - d_mov_eqsl : movie_eqsl2
; 
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

pro d_eqsl,GV,EQs

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; Check if we have all variables needed
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  

  ans1 = 'plop'
  if not EQs.haskey('quantities') then begin
     l = []
     print,'Choose a list of quantities'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     EQs['quantities'] = l
  endif
  ans1='plop'
  if not EQs.haskey('sq') then begin
     l = []
     print,'Choose a list of statistical quantities'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     EQs['sq'] = l
  endif

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
; Call to the see_eqsl routine
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  

  lq     = EQs['quantities']
  sq     = EQs['sq']

  nb_lq = size(lq) & nb_lq = nb_lq[1] 
  nb_sq = size(sq) & nb_sq = nb_sq[1] 



  for qq=0,nb_lq-1 do begin
     if qq ge nb_sq then sqq = sq[nb_sq-1] else sqq = sq[qq]
     see_eqsl2,GV['dir'],lq[qq],sqq,GV['iteration'],GV['recnum'],rbcz=GV['rbcz'],$
               glob=GV['glob'],sc=GV['sc'],notquiet=GV['notquiet'],swap=GV['swap'],$
               psf=GV['psf'],wnd=GV['wnd'],tv=1
     GV['wnd'] = GV['wnd']+1
  endfor
end

pro d_mov_eqsl,GV,EQs

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; Check if we have all variables needed
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  

  ans1 = 'plop'
  if not GV.haskey('rbcz') then begin
     ans1 = ''
     print,'Enter radiative core proportion (between 0 and 1)'
     read,ans1
     GV['rbcz'] = double(ans1)
  endif
  if not EQs.haskey('quantities') then begin
     l = []
     print,'Choose a list of quantities'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     EQs['quantities'] = l
  endif
  if not EQs.haskey('sq') then begin
     l = []
     print,'Choose a list of statistical quantities'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     EQs['sq'] = l
  endif
  if not EQs.haskey('to') then begin
     print,'Choose a time offset'
     read,ans1
     EQs['to'] = double(ans1)
  endif
  if not EQs.haskey('base') then begin
     print,'Choose an offset number of output file'
     read,ans1
     EQS['base'] = long(ans1)
  endif
  if not EQs.haskey('recperfile') then begin
     print,'Choose the number of record per file '
     read,ans1
     EQs['recperfile'] = long(ans1)
  endif

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
; Call to the eqsl movie routine
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  

  lq     = EQs['quantities']
  sq     = EQs['sq']

  nb_lq = size(lq) & nb_lq = nb_lq[1] 
  nb_sq = size(sq) & nb_sq = nb_sq[1] 

  nbf = long((GV['eend']-GV['start'])/GV['jump']+1)

  for qq=0,nb_lq-1 do begin
     if qq ge nb_sq then sqq = sq[nb_sq-1] else sqq = sq[qq]
     movie_eqsl2,GV['dir'],lq[qq],sqq,EQs['recperfile'],nbf,GV['start'],GV['jump'],rbcz=GV['rbcz'],$
                 base=EQs['base'],to=EQs['to'],glob=GV['glob'],sc=GV['sc'],notquiet=GV['notquiet'],$
                 swap=GV['swap'],psf=1,tv=1
     GV['wnd'] = GV['wnd']+1
  endfor

end

