;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;  Routines : 
; 
;      - d_flux : see_flux_balance
;      - d_shav : see_shav 
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

pro d_flux,GV
  
  if GV['build'] eq 0 then begin
     see_flux_balance2,GV['dir'],GV['iteration'],GV['recnum'],lstar=GV['lstar'],$
                       rstar=GV['rstar'],rbcz=GV['rbcz'],glob=GV['glob'],$
                       notquiet=GV['notquiet'],swap=GV['swap'],psf=GV['psf'],$
                       wnd=GV['wnd'],build=GV['build']
  endif else begin
     see_flux_balance2,GV['dir'],GV['savingIDL'],GV['recper'],GV['nfiles'],$
                       GV['start'],GV['skip'],lstar=GV['lstar'],rstar=GV['rstar'],$    
                       rbcz=GV['rbcz'],glob=GV['glob'],notquiet=GV['notquiet'],$
                       swap=GV['swap'],psf=GV['psf'],wnd=GV['wnd'],build=GV['build']
  endelse

  GV['wnd'] = GV['wnd']+1
end

pro d_shav,GV,SAs

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; Check if we have all variables needed
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  

  ans1 = 'plop'
  if not SAs.haskey('quantities') then begin
     l = []
     print,'Choose a list of quantities'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     SAs['quantities'] = l
  endif

  ans1 = 'plop'
  if not SAs.haskey('sq') then begin
     l = []
     print,'Choose a list of statistical quantities'
     while ans1 ne '' do begin
        print,'Enter a new one (type nothing if list is complete)'
        read,ans1
        if ans1 ne '' then l = [l,long(ans1)]
     endwhile
     SAs['sq'] = l
  endif

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
; Call to the see_shav routine
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  

  lq    = SAs['quantities']  
  sq    = SAs['sq'] 
  
  nb_lq = size(lq) & nb_lq = nb_lq[1]
  nb_sq = size(sq) & nb_sq = nb_sq[1]

  print,nb_lq 

  if GV['build'] gt 0 then savingIDL_base = GV['savingIDL']+'_SHAV_'

  for qq=0,nb_lq-1 do begin
     print,qq
     if qq ge nb_sq then sqq = sq[nb_sq-1] else sqq = sq[qq] ; if list of sq smaller that quantity list then it is completed by its last value
     

     if GV['build'] eq 0 then begin
        see_shav2,GV['dir'],lq[qq],GV['iteration'],GV['recnum'],sq=sqq,rstar=GV['rstar'],$
                  rbcz=GV['rbcz'],glob=GV['glob'],sc=GV['sc'],notquiet=GV['notquiet'],$
                  swap=GV['swap'],psf=GV['psf'],wnd=GV['wnd'],build=GV['build']
     endif else begin
        savingIDL = savingIDL_base+get_name2(qq)
        see_shav2,GV['dir'],lq[qq],savingIDL,GV['recper'],GV['nfiles'],GV['start'],$
                  GV['skip'],sq=sqq,rstar=GV['rstar'],rbcz=GV['rbcz'],glob=GV['glob'],$
                  sc=GV['sc'],notquiet=GV['notquiet'],swap=GV['swap'],psf=GV['psf'],$
                  wnd=GV['wnd'],build=GV['build']
     endelse
     GV['wnd'] = GV['wnd']+1
  endfor
end
