@call_scalar
@call_shav
@call_eqsl
@call_shsl
@call_azav

pro choice,choice,res

  GV = res['GlobalVariables']
  
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
; Check if GV variables are OK
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

  ; Shared variables for all routines
  if GV.HasKey('dir')     eq 0 then begin
     dir = ''
     print,'Enter a data directory ("dir" is missing in "Global Variables" section)'
     read,dir
     GV['dir'] = dir
  endif
  if GV.hasKey('hydro')    eq 0 then begin
     h = 0
     print,'Is the case only hydrodynamical ? (0/1) ("hydro" is missing in "Global Variables" )'
     read,h
     GV['hydro'] = h
  endif
  if GV.HasKey('build')    eq 0 then begin
     build = 0 
     print,'Do you want to create or read a IDL saving file ?'    
     print,'0: No'
     print,'1: Create'
     print,'2: Read'
     read,build
     GV['build'] = build
  endif
  
  ; Iterations variables
  
  switch 1 of 
     GV.HasKey('iter') eq 0 and GV.HasKey('start') eq 0: begin
        ans = ''
        print,'You need to enter an iteration file number'
        print,iter
        GV['iter']  = iter
        GV['start'] = iter
     end
     GV.HasKey('iter') eq 0 and GV.HasKey('start') eq 1: GV['iter']  = GV['start']
     GV.HasKey('iter') eq 1 and GV.HasKey('start') eq 0: GV['start'] = GV['iter']
  end
  
  if GV.HasKey('savingIDL') eq 0 then GV['savingIDL'] = 'save'
  if GV.haskey('radii')     eq 0 then GV['radii']     = [4,200,400]
  if GV.HasKey('eend')      eq 0 then GV['eend']      = GV['start']
  if GV.HasKey('jump')      eq 0 then GV['jump']      = 1000
  if GV.HasKey('rstar')     eq 0 then GV['rstar']     = 6.72e10
  if GV.HasKey('lstar')     eq 0 then GV['lstar']     = 3.46e33
  if GV.HasKey('rbcz')      eq 0 then GV['rbcz']      = 0
  if GV.HasKey('glob')      eq 0 then GV['glob']      = 0
  if GV.HasKey('sc')        eq 0 then GV['sc']        = 0
  if GV.HasKey('notquiet')  eq 0 then GV['notquiet']  =  0
  if GV.HasKey('swap')      eq 0 then GV['swap']      = 0
  if GV.HasKey('opl')       eq 0 then GV['opl']       = 0
  if GV.HasKey('psf')       eq 0 then GV['psf']       = 0
  if GV.haskey('wnd')       eq 0 then GV['wnd']       = 0
  
  ; Different choices
  case choice of 
     '0': begin
        name=''
        while name eq '' do begin
           print,'Enter new file name : '
           read,name
        endwhile
        GV = dictionary()
        GV['dir']=name
        return
     end
     '1' : begin
        if res.haskey('Scalar') eq 0 then SC = dictionary() else SC = res['Scalar']
        d_scalar,GV,SC
     end
     '2' : begin
        if res.haskey('ShellAverages') eq 0 then SAs = dictionary() else SAs = res['ShellAverages']
        d_shav,GV,SAs
     end
     '3' : begin
        if res.haskey('EquatorialSlices') eq 0 then EQs = dictionary() else EQs = res['EquatorialSlices']
        d_eqsl,GV,EQs
     end
     '4' : begin
        if res.haskey('ShellSlices') eq 0 then SHs = dictionary() else SHs = res['ShellSlices']
        d_shsl,GV,SHs,GV['envision']
     end
     '5'  : begin
        if res.haskey('AzimuthalAverages') eq 0 then AZ = dictionary() else AZ = res['AzimuthalAverages']
        d_azav,GV,AZ
     end
     '6'  : begin
        d_flux,GV
     end
     '7'  : begin
        if res.haskey('Spectra') eq 0 then SP = dictionary() else SP = res['Spectra']
        d_spectra,GV,SP
     end
     '8'  : begin
        if res.haskey('ButterflyDiagram') eq 0 then BD = dictionary() else BD = res['ButterflyDiagram']
        d_butterfly_lat,GV,BD
     end 
     '9'  : begin
        if res.haskey('ButterflyDiagram') eq 0 then BD = dictionary() else BD = res['ButterflyDiagram']
        d_butterfly_rad,GV,BD
     end 
     '10': begin
        if res.haskey('AngularMomentum') eq 0 then AM = dictionary() else AM = res['AngularMomentum']
        d_angmom,GV,AM
     end
     '11': begin
        if res.haskey('MagneticFieldProduction') eq 0 then MFP = dictionary() else MFP = res['MagneticFieldProduction']
        d_magfieldprod,GV,MFP
     end
     '12': begin
        if res.haskey('AlphaOmegaEffect') eq 0 then AOE = dictionary() else AOE = res['AlphaOmegaEffect']
        d_alphaomega,GV,AOE
     end
     '16' : begin
        if res.haskey('EquatorialSlices') eq 0 then EQs = dictionary() else EQs = res['EquatorialSlices']
        d_mov_eqsl,GV,EQs
     end
     '19' : begin
        if res.haskey('ShellSlices') eq 0 then SHs = dictionary() else SHs = res['ShellSlices']
        d_mov_shsl,GV,SHs,0
     end
     '20' : begin
        if res.haskey('ShellSlices') eq 0 then SHs = dictionary() else SHs = res['ShellSlices']
        d_mov_shsl,GV,SHs,1
     end
     '14' : begin
        if res.haskey('AzimuthalAverages') eq 0 then AZ = dictionary() else AZ = res['AzimuthalAverages']
        d_mov_azav,GV,AZ
     end
     else: print,'Diagnostic not implemented yet ...'
  endcase
end
        

