;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;  Routines : 
; 
;      - get_name2
;      - get_scalar_name2
;      - get_scalar_to_shav_name2
;      - get_azav_name2     
; 
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

function dict_2D,output
  dd    = dictionary()
  dd['0'] = output
  for i = 1,250 do begin
     name = get_name2(i)
     ii   = strcompress(i,/r) 
     if name ne '' then begin
        dd[ii]   = name
        dd[name] = ii
     endif 
  endfor
  return,dd
end

function dict_scalar
  dd    = dictionary()
  dd[0] = 'Scalar'
  for i= 1,250 do begin
     name = get_scalar_name2(i)
     ii  = strcompress(i,/r)
     if name ne '' then begin
        dd[ii]   = name
        dd[name] = ii
     endif
  endfor
  return,dd
end

function get_name2, quantity

  case quantity of
     1:   name =  'Vr'
     2:   name =  'Vtheta'
     3:   name =  'Vphi'  
     4:   name =  'Entropy'
     5:   name =  'Pressure' 
     6:   name =  'Temperature'
     7:   name =  'Radial Mass Flux'
     8:   name =  'Meridional Mass Flux'
     9:   name =  'Zonal Mass Flux'
     10:  name =  'Kinetic Energy'
     11:  name =  'Meridional Kinetic Energy Flux'
     12:  name =  'Radial Kinetic Energy Flux'
     13:  name =  'Momentum Flux: r theta'
     14:  name =  'Momentum Flux: r phi'
     15:  name =  'Momentum Flux: theta phi'
     16:  name =  'Momentum Flux: r r'
     17:  name =  'Momentum Flux: theta theta'
     18:  name =  'Momentum Flux: phi phi'
     19:  name =  'Meridional Enthalpy Flux'
     20:  name =  'Radial Enthalpy Flux'
     21:  name =  'Pressure Work'
     22:  name =  'Kinetic Helicity'
     23:  name =  'Enstrophy'
     24:  name =  'Bouancy Work'
     28:  name =  'Density'
     29:  name =  'Viscous Work'
     30:  name =  'Div. Kinetic Energy FLux'
     31:  name =  'Latitudinal Viscous Flux'
     32:  name =  'Radial Viscous Flux'
     33:  name =  'Latitudinal Gravity Flux'
     34:  name =  'Radial Gravity Flux'
     35:  name =  'Latitudinal Entropy FLux'
     36:  name =  'Radial Entropy Flux'
     37:  name =  'Latitudinal Radiation Flux'
     38:  name =  'Radial Radiation Flux'
     40:  name =  'Angular Momentum'
     41:  name =  'Entropy Gradient'
     42:  name =  'Rayleigh Number'
     43:  name =  'DRKE'
     44:  name =  'MCKE'
     45:  name =  'CKE'
     46:  name =  'Rossby Number'
     47:  name =  'Convective Rossby Number'
     48:  name =  'Radial Vorticity'
     49:  name =  'Horizontal Vorticity'
     50:  name =  'Acoustic Flux'
     51:  name =  'Variation of Density'
     52:  name =  'Variation of Temperature'
     61:  name =  'Br'
     62:  name =  'Btheta'
     63:  name =  'Bphi'
     64:  name =  'Radial Current'
     65:  name =  'Meridional Current'
     66:  name =  'Zonal Current'
     67:  name =  'Magnetic Energy'
     68:  name =  'Latitudinal Poynting Flux'
     69:  name =  'Radial Poynting Flux'
     70:  name =  'Mixed Mag Flux: theta r'
     71:  name =  'Mixed Mag Flux: theta theta '
     72:  name =  'Mixed Mag Flux: theta r'
     73:  name =  'Mixed Mag Flux: r r'
     74:  name =  'Mixed Mag Flux: r theta'
     75:  name =  'Mixed Mag Flux: r phi'
     76:  name =  'Magnetic Helicity'
     77:  name =  'Rate of Magnetic Work'
     78:  name =  'Cross Helicity'
     79:  name =  'Square of electric current'
     80:  name =  'Current Helicity'
     81:  name =  'Omega effect'
     82:  name =  'Alpha effect'
     83:  name =  'Emf_r'
     84:  name =  'Emf_t'
     85:  name =  'Emf_p'
     86:  name =  'Prod_TME_M'
     87:  name =  'Prod_TME_F'
     91:  name =  'TME'
     92:  name =  'PME'
     93:  name =  'FME'
     94:  name =  'FTE'
     95:  name =  'FPE'
     96:  name =  'Full_ToroME'
     97:  name =  'Full_PoloME'
     98:  name =  'Full_FluctToroME'
     99:  name =  'Full_FluctPoloME'
     110: name =  'Dyn_shear_r'
     111: name =  'Dyn_shear_t'
     112: name =  'Dyn_shear_p'
     113: name =  'Dyn_shear_r_mean'
     114: name =  'Dyn_shear_t_mean'
     115: name =  'Dyn_shear_p_mean'
     116: name =  'Dyn_advec_r'
     117: name =  'Dyn_advec_t'
     118: name =  'Dyn_advec_p'
     119: name =  'Dyn_advec_r_mean'
     120: name =  'Dyn_advec_t_mean'
     121: name =  'Dyn_advec_p_mean'
     122: name =  'Dyn_comp_r'
     123: name =  'Dyn_comp_t'
     124: name =  'Dyn_comp_p'
     128: name =  'Omega_effect'
     130: name =  'Bpol_r'
     131: name =  'Bpol_t'
     132: name =  'Bpol_p'
     133: name =  'Btor_t'
     134: name =  'Btor_p'
     135: name =  'Vortr_shear'
     136: name =  'Vortr_advec'
     137: name =  'Vortr_om'
     138: name =  'Vortr_comp'
     139: name =  'Vortr_diff'
     140: name =  'Vortr_mag'
     141: name =  'Vortr_curr'
     142: name =  'Vortr_magcomp'
     else : name=' '
     
  endcase
  return, name
end

function get_scalar_name2, quantity

  case quantity of
     1    : name='Kinetic Energy'
     2    : name='Angular Momentum'
     3    : name='Enthalpy Flux'
     4    : name='Temperature Perturbation'
     5    : name='Mach Number'
     6    : name='Bouancy Work'
     7    : name='Kinetic Helicity'
     8    : name='Enstrophy'
     9    : name='DRKE'
     10   : name='MCKE'
     11   : name='Mass Flux Helicity'
     12   : name='CKE'
     13   : name='Potential Energy'
     14   : name='Internal Energy'
     15   : name='Viscous Work'
     61   : name='Magnetic Energy'
     62   : name='Magnetic Helicity'
     63   : name='Poloidal ME'
     64   : name='Toroidal ME'
     65   : name='TME'
     66   : name='PME'
     67   : name='FME'
     68   : name='Mag Work'
     69   : name='Ohmic Dissipation'
     70   : name='Cross Helicity'
     71   : name='Current Helicity'
     72   : name='Mean Prod Term Btor'
     73   : name='Fluct Prod Term Btor'
     74   : name='FPE'
     75   : name='FTE'
     76   : name='PME'
     77   : name='TME'
     else : name=' ' 
  endcase
  return,name
end   

function get_scalar_to_shav_name2,q

  case q of 
     1: res = 10
     2: res = -2
     3: res = 20
     4: begin
        print,'Temperature perturbation does not exist in SHAV'
        res = 0
     end
     5: begin
        print,'Mach number does not exist in SHAV'
        res = 0
     end
     6: res = 24
     7: res = 22
     8: res = 23
     9: res = 43
     10: res = 44
     11: begin
        print,'Mass flux helicity does not exist in SHAV'
        res = 0
     end
     12: res = 45
     13: begin
        print,'Potential energy does not exist in SHAV'
        res = 0
     end 
     14: begin
        print,'Internal energy does not exist in SHAV'
        res = 0
     end
     15: res = 20
     61: res = 67
     62: res = 76
     63: res = -63 
     64: res = -64
     65: res = 91
     66: res = 92
     67: res = 93
     68: res = 77
     70: res = 78
     71: res = 80
     else: begin
        print,'This variable is not implemented in SHAV'
        res = 0
     end
  endcase  
  return,res
end

function get_azav_name2,q
  
  case q of
     1  : return,'Velocity'
     2  : return,'Specific Entropy'
     -2 : return,'Specific Radial Entropy Gradient'
     3  : return,'!7 X !17Average'
     4  : return,'Pressure/10!U8!N'
     5  : return,'Temperature'
     6  : return,'Magnetic field'
     7  : return,'Radial Enthalpy flux'
     85 : return,'Emf_p'
     128: return,'Omega_effect'
     else: return,''
  endcase
end

function get_amom_name2,mag=mag,short=short

  if not keyword_set(mag)   then mag   = 0
  if not keyword_set(short) then short = 0

  if mag eq 1 then begin
     title=strarr(13)
  endif else begin
     title=strarr(9)
  endelse

  if short eq 0 then begin
     title(0) = 'Radial Non-Axy Reynolds Stresses from Convection'
     title(1) = 'Latitudinal Non-Axy Reynolds Stresses from Convection'
     title(2) = 'Radial Axy Reynolds Stresses from Diff Rot'
     title(3) = 'Latitudinal Axy Reynolds Stresses from Diff Rot'
     title(4) = 'Coriolis Forces on radial flows'
     title(5) = 'Coriolis Forces on horizontal flows'
     title(6) = 'Radial Viscous Diffusion'
     title(7) = 'Latitudinal Viscous Diffusion'
     title(8) = 'Thermal Wind'
     
     if mag eq 1 then begin
        title(9) = 'Radial Non-Axy Magnetic Stresses'
        title(10) = 'Latitudinal Non-Axy Magnetic Stresses'
        title(11) = 'Radial Axy Magnetic Stresses'
        title(12) = 'Latitudinal Axy Magnetic Stresses'
     endif
  endif else begin
     title(0) = 'RNC'  
     title(1) = 'LNC'
     title(2) = 'RDR'  
     title(3) = 'LDR'
     title(4) = 'RCF'
     title(5) = 'LCF' 
     title(6) = 'RVD' 
     title(7) = 'LVD' 
     title(8) = 'Thermal Wind'
     if mag eq 1 then begin   
        title(9) = 'RMC' 
        title(10) = 'LMC'   
        title(11) = 'RMM' 
        title(12) = 'LMM' 
     endif            
  endelse
  
  return,title

end

function extract_name,name,character
  
  res     = name 
  dot_pos = STRPOS(name,character,/REVERSE_SEARCH)
  if dot_pos gt -1 then res = STRMID(name,0,dot_pos)
  return,res 

end









