function j0,x
  return,sin(x)/x
end

function j1,x
  return,sin(x)/x^2-cos(x)/x
end

function y0,x
  return,-cos(x)/x
end

function y1,x
  return,-cos(x)/x^2-sin(x)/x
end 

function get_Br,r,theta,alpha,beta,gamma,K10,K20
  nr = size(r)     & nr = nr(1)
  nt = size(theta) & nt = nt(1)
  res = dblarr(nt,nr)
  
  res(*) = (beta+gamma)/alpha^2
  for it = 0,nt-1 do begin
     res(it,*) = res(it,*) + K10*abs(alpha)/r*j1(abs(alpha)*r)
     res(it,*) = res(it,*) + K20*abs(alpha)/r*y1(abs(alpha)*r)
  endfor
  for ir = 0,nr-1 do begin
     res(ir,*) = res(ir,*)*2*cos(theta)
  endfor
  retun,res
end

function get_Bt,r,theta,alpha,beta,gamma,K10,K20
  nr = size(r)     & nr = nr(1)
  nt = size(theta) & nt = nt(1)
  res = dblarr(nt,nr)
  
  res(*) = 2*(beta+gamma)/alpha^2
  for it = 0,nt-1 do begin
     res(it,*) = res(it,*) + K10*abs(alpha)/r*(-j1(abs(alpha)*r)+abs(alpha)*r*j0(abs(alpha)*r))
     res(it,*) = res(it,*) + K20*abs(alpha)/r*(-y1(abs(alpha)*r)+abs(alpha)*r*y0(abs(alpha)*r))
  endfor
  for ir = 0,nr-1 do begin
     res(ir,*) = -res(ir,*)*sin(theta)
  endfor
  retun,res
end

function get_Bp,r,theta,alpha,beta,gamma,K10,K20
  nr = size(r)     & nr = nr(1)
  nt = size(theta) & nt = nt(1)
  res = dblarr(nt,nr)
  
  res(*) = 0.0
  for it = 0,nt-1 do begin
     res(it,*) = res(it,*) - beta*r/alpha 
     res(it,*) = res(it,*) - K10*abs(alpha)*alpha*j1(abs(alpha)*r)
     res(it,*) = res(it,*) - K20*abs(alpha)*alpha*y1(abs(alpha)*r)
  endfor
  for ir = 0,nr-1 do begin
     res(ir,*) = res(ir,*)*sin(theta)
  endfor
  retun,res
end
