@sign

pro parser,driver_input,res

  close,/all
  
  key_string = ['dir','file','fn1']
  key_int    = ['base','build','eend','envision','glob','horiz','hydro','icutmax','idmx','iteration','jump','lc','legendd','notquiet','nt','on','opl','ortho','psf','recnum','recperfile','sc','start','swap','wnd','zone']
  key_dbl    = ['gr','lstar','rbcz','rstar','to']
  key_list   = ['depth','quantities','radii','sq']
  
  openr,1,driver_input 
  
  res   = dictionary()  
  
  i     = 0
  title = ''
  d_aux = dictionary()
  
  line  = '' 
  while not eof(1) do begin 
     
     readf,1, line 
     len=strlen(line) 
     
     j=strpos(line,'^^^')
     
     if j eq 0 then begin       ;  ^^^^^^ line
        i = i+1
     endif else begin
        if (i mod 2) eq 1 then begin ; title line
           if title ne '' then begin
              res[title] = d_aux
           endif
           title = strcompress(line,/REMOVE_ALL)
           d_aux = dictionary()
        endif else begin 
           ii      = strpos(line,'=')
           if ii gt 0 then begin ; variable line
              keyword = strtrim(strmid(line,0,ii),2)
              keyword = strcompress(keyword,/remove_all) 
              value   = strmid(line,ii+2,len-ii-2)
              value   = strcompress(value,/remove_all)
              if value ne '' then begin
                 if where(key_string eq keyword) ge 0 then begin ; string value
                    d_aux[keyword] = value
                 endif else begin
                    value = str_replace(value,'d','e')
                    value = str_replace(value,'D','e')
                    value = str_replace(value,'E','e')           
                    if where(key_int eq keyword) ge 0 then begin ; int value
                       value = long(value)
                       d_aux[keyword] = value
                    endif else if where(key_dbl eq keyword) ge 0 then begin ; double value
                       value = float(value)
                       d_aux[keyword] = value 
                    endif else if where(key_list eq keyword) ge 0 then begin ; list value
                       value = strsplit(value,',',/extract)
                       value = float(value)
                       d_aux[keyword] = value
                    endif else begin
                       print,'Keyword ',keyword,' not in name lists. If you created it, please add it to lists at the beginning of the "parser.pro" routine'
                    endelse
                 endelse
              endif
           endif
        endelse
     endelse
  endwhile
end
