;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ 
; read2.pro   - Read variables
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ 

pro read2,type,dir,qq,file,recnum,sq=sq,rbcz=rbcz,omega=omega,notquiet=notquiet,$
          swap=swap,f=f,iteration=iteration,time=time,deltat=deltat,name=name,$
          rad=rad,theta=theta,phi=phi,nphi=nphi,nlats=nlats
  
  case type of 
     'SCALAR': read_scalar2,dir,qq,file,sq=sq,rbcz=rbcz,notquiet=notquiet,swap=swap,$
                            f=f,iteration=iteration,time=time,deltat=deltat,name=name
     'SHAV'  : read_shav2,dir,qq,file,sq=sq,notquiet=notquiet,swap=swap,f=f,$
                          iteration=iteration,time=time,deltat=deltat,name=name,rad=rad
     'SHSL'  : read_shsl2,dir,qq,file,sq=sq,notquiet=notquiet,swap=swap,$
                          f=f,iteration=iteration,time=time,deltat=deltat,name=name,$
                          rad=rad,theta=theta,phi=phi
     'AZAV'  : read_azav2,dir,qq,file,omega=omega,notquiet=notquiet,swap=swap,$
                          f=f,iteration=iteration,time=time,deltat=deltat,name=name,$
                          rad=rad,theta=theta
     'EQSL'  : read_eqsl2,dir,qq,file,sq=sq,notquiet=notquiet,swap=swap,f=f,$
                          iteration=iteration,time=time,deltat=deltat,name=name,$
                          rad=rad,nphi=nphi,nlats=nlats
     'POSL'  : begin
        print,'Read POSL not implemented yet ...'
     end
  end
end
